function bg2saveHighscore()
	file = io.open("bg2hsf", "w")
	if file then
		for i = 1, 5 do
			file:write(bg2highscores[i][1], " ")
			file:write(bg2highscores[i][2], " ")
		end
		file:close()
	end
end

function bg2loadHighscore()
	file = io.open("bg2hsf", "r")
	if file then
		for i=1, 5 do
			bg2highscores[i][1] = file:read(3)
			if bg2highscores[i][1] == null then
				bg2highscores[i][1] = 0
			end
			bg2highscores[i][2] = file:read("*n")
			if bg2highscores[i][2] == null then
				bg2highscores[i][2] = 0
			end
			local dump = file:read(1)
		end
		file:close()
		dump = null
	end
end

function unloadfunctions()
bg2saveHighscore = null
bg2loadHighscore = null
loadb2graphics = null
unloadb2graphics = null
loadintrobg2 = null
unloadintrobg2 = null
bg2intro = null
drawEnvironment2 = null
initvalues = null
uninitvalues = null
drawwalk = null
bonus2death = null
bonus2victory = null
bonus2end = null
playbonus2 = null
collectgarbage()
end

function loadb2graphics()
	fadein(loadscreen, 30, 0)
	water1 = Image.load("images/bonusgame2/water1.png")
	water2 = Image.load("images/bonusgame2/water2.png")
	man = {}
	legs = {}
	sub1 = {}
	sub2 = {}
	sub3 = {}
	sub4 = {}
	wl = {}
	wr = {}
	man[3] = Image.load("images/bonusgame2/torsol1.png")
	man[2] = Image.load("images/bonusgame2/torsol2.png")
	man[1] = Image.load("images/bonusgame2/torsol3.png")
	man[5] = Image.load("images/bonusgame2/torsor1.png")
	man[6] = Image.load("images/bonusgame2/torsor2.png")
	man[7] = Image.load("images/bonusgame2/torsor3.png")
	man[4] = Image.load("images/bonusgame2/torsom.png")
	legs[2] = Image.load("images/bonusgame2/legd3.png")
	legs[1] = Image.load("images/bonusgame2/legf1.png")
	legs[3] = Image.load("images/bonusgame2/legf2.png")
	sub1[1] = Image.load("images/bonusgame2/sub1f1.png")
	sub1[2] = Image.load("images/bonusgame2/sub1f2.png")
	sub1[3] = Image.load("images/bonusgame2/sub1f3.png")
	sub2[1] = Image.load("images/bonusgame2/sub2f1.png")
	sub2[2] = Image.load("images/bonusgame2/sub2f2.png")
	sub2[3] = Image.load("images/bonusgame2/sub2f3.png")
	sub3[1] = Image.load("images/bonusgame2/sub3f1.png")
	sub3[2] = Image.load("images/bonusgame2/sub3f2.png")
	sub3[3] = Image.load("images/bonusgame2/sub3f3.png")
	sub4[1] = Image.load("images/bonusgame2/sub4f1.png")
	sub4[2] = Image.load("images/bonusgame2/sub4f2.png")
	sub4[3] = Image.load("images/bonusgame2/sub4f3.png")
	wl[1] = Image.load("images/bonusgame2/wlf1.png")
	wl[2] = Image.load("images/bonusgame2/wlf2.png")
	wl[3] = Image.load("images/bonusgame2/wlf3.png")
	wl[4] = Image.load("images/bonusgame2/wlf4.png")
	wl[5] = Image.load("images/bonusgame2/wlf5.png")
	wr[1] = Image.load("images/bonusgame2/wrf1.png")
	wr[2] = Image.load("images/bonusgame2/wrf2.png")
	wr[3] = Image.load("images/bonusgame2/wrf3.png")
	wr[4] = Image.load("images/bonusgame2/wrf4.png")
	wr[5] = Image.load("images/bonusgame2/wrf5.png")
	victoryscroll = Image.load("images/bonusgame2/victoryscroll.png")
	ready = Image.load("images/bonusgame2/ready.png")
	set = Image.load("images/bonusgame2/set.png")
	go = Image.load("images/bonusgame2/go.png")
	bg2hs = Image.load("images/score/bg2hs.png")
	distmeter = Image.load("images/bonusgame2/distancemeter .png")
	splash = Sound.load("sounds/splash.wav")
	option = Image.load("images/bonusgame1/xo.png")
	fadeout(loadscreen, 30, 0)
end

function unloadb2graphics()
	water1 = null
	water2 = null
	man[1] = null
	man[2] = null
	man[3] = null
	man[5] = null
	man[6] = null
	man[7] = null
	man[4] = null
	legs[1] = null
	legs[2] = null
	legs[3] = null
	sub1[1] = null
	sub1[2] = null
	sub1[3] = null
	sub2[1] = null
	sub2[2] = null
	sub2[3] = null
	sub3[1] = null
	sub3[2] = null
	sub3[3] = null
	sub4[1] = null
	sub4[2] = null
	sub4[3] = null
	wl[1] = null
	wl[2] = null
	wl[3] = null
	wl[4] = null
	wl[5] = null
	wr[1] = null
	wr[2] = null
	wr[3] = null
	wr[4] = null
	wr[5] = null
	wl = null
	wr = null
	man = null
	legs = null
	sub1 = null
	sub2 = null
	sub3 = null
	sub4 = null
	victoryscroll = null
	ready = null
	set = null
	go = null
	bg2hs = null
	distmeter = null
	splash = null
	option = null
	uninitvalues()
	collectgarbage()
end

function loadintrobg2()
	fadein(loadscreen, 30, 0)
	frame1 = Image.load("images/bonusgame2/subrf1.png")
	frame2 = Image.load("images/bonusgame2/subrf2.png")
	frame3 = Image.load("images/bonusgame2/subrf3.png")
	frame4 = Image.load("images/bonusgame2/subrf4.png")
	frame5 = Image.load("images/bonusgame2/subrf5.png")
	frame6 = Image.load("images/bonusgame2/subrf6.png")
	frame7 = Image.load("images/bonusgame2/subrf7.png")
	fadeout(loadscreen, 30, 0)
end

function unloadintrobg2()
	frame1 = null
	frame2 = null
	frame3 = null
	frame4 = null
	frame5 = null
	frame6 = null
	frame7 = null
	frame8 = null
	frame9 = null
	frame10 = null
	frame11 = null
	collectgarbage()
end

function bg2intro()
	skip = 0
	loadintrobg2()
	Music.playFile("sounds/d0xeh.mod", true )

	fadein(frame1, 15, skip)
	movieskip(skip, 180)
	fadeout(frame1, 15, skip)

	frame1 = null
	frame8 = Image.load("images/bonusgame2/subrf8.png")
	fadein(frame2, 15, skip)
	movieskip(skip, 180)
	fadeout(frame2, 15, skip)

	
	frame2 = null
	frame9 = Image.load("images/bonusgame2/subrf9.png")
	fadein(frame3, 15, skip)
	movieskip(skip, 180)
	fadeout(frame3, 15, skip)

	
	frame3 = null
	frame10 = Image.load("images/bonusgame2/subrf10.png")
	fadein(frame4, 15, skip)
	movieskip(skip, 180)
	fadeout(frame4, 15, skip)

	
	frame4 = null
	frame11 = Image.load("images/bonusgame2/subrf11.png")
	fadein(frame5, 15, skip)
	movieskip(skip, 180)
	fadeout(frame5, 15, skip)

	frame5 = null
	fadein(frame6, 15, skip)
	movieskip(skip, 180)
	fadeout(frame6, 15, skip)

	frame6 = null
	fadein(frame7, 15, skip)
	movieskip(skip, 180)
	fadeout(frame7, 15, skip)

	fadein(frame8, 15, skip)
	movieskip(skip, 180)
	fadeout(frame8, 15, skip)

	fadein(frame9, 15, skip)
	movieskip(skip, 180)
	fadeout(frame9, 15, skip)

	fadein(frame10, 15, skip)
	movieskip(skip, 180)
	fadeout(frame10, 15, skip)

	fadein(frame11, 15, skip)
	movieskip(skip, 180)
	fadeout(frame11, 15, skip)

	musicfadeout()
	Music.stop()
	Music.volume(gamevolume)
	unloadintrobg2()
end

function drawEnvironment2()
	dseabg = dseabg + 1
	screen:blit(0, 0, water1)
	screen:blit(0 - dseabg, 144, water2)
	screen:blit(480 - dseabg, 144, water2)
	if dseabg == 480 then
		dseabg = 0
	end
	dsea2 = dsea2 + 1
	watertrack = watertrack + watermotion
	if watertrack <= 0 or watertrack >= 5 then
		watermotion = watermotion * -1
		dsea = dsea + 1
	end
	distrem = distrem - 1
	distrem2 = distrem2 + 1
	if distrem2 == 30 then
		distrem2 = 0
		distremcount = distremcount - 1
	end
	kdelay = kdelay - 1
	if distrem < 900 then
		screen:blit(100, 0+k, sub4[k])
		if k >= 3 then
			kmotion = -1
		end
		if k <= 1 then
			kmotion = 1
		end
		if kdelay <= 0 then
			k = k + kmotion
			kdelay = 5
		end
	elseif distrem < 1800 then
		screen:blit(140, 30+k, sub3[k])
		if k >= 3 then
			kmotion = -1
		end
		if k <= 1 then
			kmotion = 1
		end
		if kdelay <= 0 then
			k = k + kmotion
			kdelay = 5
		end
	elseif distrem < 2700 then
		screen:blit(180, 65+k, sub2[k])
		if k >= 3 then
			kmotion = -1
		end
		if k <= 1 then
			kmotion = 1
		end
		if kdelay <= 0 then
			k = k + kmotion
			kdelay = 5
		end
	elseif distrem < 3600 then
		screen:blit(200, 90+k, sub1[k])
		if k >= 3 then
			kmotion = -1
		end
		if k <= 1 then
			kmotion = 1
		end
		if kdelay <= 0 then
			k = k + kmotion
			kdelay = 5
		end
	end
	screen:blit(130, 5, distmeter)
	screen:print(275, 15, distremcount .. " Feet", black)
end

function initvalues()
	watermotion = 1
	watertrack = 1
	dsea = 0
	dsea2 = 0
	dseabg = 0
	stumbletrack = 300
	stumble = 0
	stumblemotion = 2
	currentx = 190
	distrem = 3600
	stumblemax = 10
	stumblemax2 = 10
	stumbledelay = stumblemax2
	stumbledelay2 = stumblemax
	j = 1
	jmotion = 1
	jdelay = 7
	k = 1
	kmotion = 1
	kdelay = 5
	bg2endtest = 0
	distrem2 = 0
	distremcount = 120
	bg2highscores = {}
	for i=1,5 do
		bg2highscores[i] = {}
		bg2highscores[i][1] = 0
		bg2highscores[i][2] = 0
	end
end


function uninitvalues()
	watermotion = null
	watertrack = null
	dsea = null
	dsea2 = null
	dseabg = null
	stumbletrack = null
	stumble = null
	stumblemotion = null
	currentx = null
	distrem = null
	stumblemax = null
	stumblemax2 = null
	stumbledelay = null
	stumbledelay2 = null
	j = null
	jmotion = null
	jdelay = null
	k = null
	kmotion = null
	kdelay = null
	bg2endtest = null
	distrem2 = null
	distremcount = null
	bg2highscores = null
end

function drawwalk()
	if stumbletrack == 0 then
		stumblemotion = math.random(-4,4)
		stumbletrack = 300
	end
	if stumblemotion < 0 and stumblemotion > -6 and stumbledelay <= 0 then
		stumblemotion = stumblemotion - 1
		stumbledelay = stumblemax2
	end
	if stumblemotion > 0 and stumblemotion < 6 and stumbledelay <= 0 then
		stumblemotion = stumblemotion + 1
		stumbledelay = stumblemax2
	end
	if stumblemotion == 0 and stumbledelay <= 0 then
		stumblemotion = math.random(-2,2)
		stumbledelay = stumblemax2
	end
	stumbletrack = stumbletrack - 1
	stumbledelay = stumbledelay - 1
	stumbleset = stumblemotion + stumble
	if currentx + (stumbleset) > 360 then
		currentx = 360
		bonus2death(2)
	elseif currentx + (stumbleset) < -100 then
		currentx = -100
		bonus2death(1)
	else
		currentx = currentx + (stumbleset)
	end
	if currentx < 34 then
		i = 1
	elseif currentx < 88 then
		i = 2
	elseif currentx < 142 then
		i = 3
	elseif currentx < 196 then
		i = 4
	elseif currentx < 250 then
		i = 5
	elseif currentx < 304 then
		i = 6
	elseif currentx < 360 then
		i = 7
	end
	if j == 1 then
		jmotion = 1
	end
	if j == 3 then
		jmotion = -1
	end
	if jdelay == 0 then
		j = j + jmotion
		jdelay = 10
	end
	jdelay = jdelay - 1
	if j < 1 or j > 3 then
		j = 1
	end
	screen:blit(currentx+54, 155, legs[j])
	screen:blit(currentx, 60, man[i])
end

function bonus2death(side)
	splash:play()
	for jj=0, 25 do
		dseabg = dseabg + 1
		screen:blit(0, 0, water1)
		screen:blit(0 - dseabg, 144, water2)
		screen:blit(480 - dseabg, 144, water2)
		if dseabg == 480 then
			dseabg = 0
		end
		if side == 1 then
			if jj < 5 then
				screen:blit(0, 147, wl[1])
			elseif jj < 10 then
				screen:blit(0, 147, wl[2])
			elseif jj < 15 then
				screen:blit(0, 147, wl[3])
			elseif jj < 20 then
				screen:blit(0, 147, wl[4])
			elseif jj < 25 then
				screen:blit(0, 147, wl[5])
			end
		end
		if side == 2 then
			if jj < 5 then
				screen:blit(330, 147, wr[1])
			elseif jj < 10 then
				screen:blit(330, 147, wr[2])
			elseif jj < 15 then
				screen:blit(330, 147, wr[3])
			elseif jj < 20 then
				screen:blit(330, 147, wr[4])
			elseif jj < 25 then
				screen:blit(330, 147, wr[5])
			end
		end
		screen:blit(130, 5, distmeter)
		screen:print(275, 15, distremcount .. " Feet", black)
		screen.flip()
		screen.waitVblankStart(1)
	end
	bonus2end()
end

function bonus2victory()
	Music.playFile("sounds/doskpop.mod", true )
	for i = 0, 120 do
		screen:blit(0, 0, water1)
		screen:blit(0 - dseabg, 144, water2)
		screen:blit(480 - dseabg, 144, water2)
		screen:blit(130, 5, distmeter)
		screen:print(275, 15, distremcount .. " Feet", black)
		if (i*10) < 300 then
			tempi = (i * 10)
		else
			tempi = 300
		end
		screen:blit(480-tempi, 120, victoryscroll)
		screen.flip()
		screen.waitVblankStart(1)
	end
	bonus2end()
end

function bonus2end()
	bg2loadHighscore()
	for i = 1, 5 do
		if bg2highscores[i][2] == null then
			bg2highscores[i][2] = (120 - distremcount)
			enterhighscore(i, bg2highscores)
			bg2saveHighscore()
			break
		end
		if (120 - distremcount) > bg2highscores[i][2] then
			if i < 5 then
				j = 5
				while j > i do
					bg2highscores[j][1] = bg2highscores[j-1][1]
					bg2highscores[j][2] = bg2highscores[j-1][2]
					j = j - 1
				end
			end
			bg2highscores[i][2] = (120 - distremcount)
			enterhighscore(i, bg2highscores)
			bg2saveHighscore()
			break
		end
	end
	local n = 272
	Music.stop()
	while true do
		pad = Controls.read()
		screen:blit(0, 0, water1)
		screen:blit(0, n, option)
		screen:blit(130, 5, distmeter)
		screen:print(275, 15, distremcount .. " Feet", black)
		screen.flip()
		screen.waitVblankStart(1)
		if n > 200 then
				n = n - 5
		end
		if pad:cross() then
			bg2endtest = 1
			break
		end
		if pad:circle() then
			bg2endtest = 2
			break
		end
		if pad:triangle() then
			while pad:triangle() do
				pad = Controls.read()
			end
			bg2loadHighscore()
			screen:clear()
			screen:blit(0,0,bg2hs)
			for i=1,5 do
				if bg2highscores[i][1] ~= null then
					printchar(100,45 + (i*25), string.sub(bg2highscores[i][1],1,1))
					printchar(125,45 + (i*25), string.sub(bg2highscores[i][1],2,2))
					printchar(150,45 + (i*25), string.sub(bg2highscores[i][1],3,3))
				end
				if bg2highscores[i][2] ~= null then
					temp1 = math.floor(bg2highscores[i][2] / 100)
					temp2 = math.floor((bg2highscores[i][2] - (temp1*100)) / 10)
					temp3 = bg2highscores[i][2] - (temp1*100) - (temp2*10)
					intprint(200, 45 + (i*25), temp1)
					intprint(225, 45 + (i*25), temp2)
					intprint(250, 45 + (i*25), temp3)
					screen:print(280, 50 + (i*25), "Feet", white)
				end
			end
			screen.flip()
			while true do
				pad = Controls.read()
				if pad:circle() then
					while pad:circle() do
						pad = Controls.read()
					end
					break
				end
				screen.waitVblankStart(1)
			end
		end
	end
end

function playbonus2()
	Music.playFile("sounds/cn_dragn.xm", true )
	for i = 0, 180 do
		screen:blit(0, 0, water1)
		screen:blit(130, 5, distmeter)
		screen:print(275, 15, distremcount .. " Feet", black)
		if i < 60 then
			screen:blit(220, 100, ready)
		elseif i < 120 then
			screen:blit(220, 100, set)
		else
			screen:blit(220, 100, go)
		end
		screen.flip()
		screen.waitVblankStart(1)
	end
	while true do
		pad = Controls.read()
		drawEnvironment2()
		drawwalk()
		if distremcount <= 0 then
			bonus2victory()
		end
		if bg2endtest == 1 or bg2endtest == 2 then
			break
		end
		screen.flip()
		screen.waitVblankStart(1)
		if stumble > 0 and stumbledelay2 <= 0 then
			stumble = stumble - 1
		end
		if stumble < 0 and stumbledelay2 <= 0 then
			stumble = stumble + 1
		end

		if pad:analogX() > 30 and pad:analogX() < 100 and stumbledelay2 <= 0 then
			if stumble < 8 then
				stumble = stumble + 2
				stumbledelay2 = stumblemax
			end
		end
		if pad:analogX() >= 100 and stumbledelay2 <= 0 then
			if stumble < 8 then
				stumble = stumble + 4
				stumbledelay2 = stumblemax
			end
		end
		if pad:analogX() < -30 and pad:analogX() > -100 and stumbledelay2 <= 0 then
			if stumble > -8 then
				stumble = stumble + -2
				stumbledelay2 = stumblemax
			end
		end
		if pad:analogX() <= -100 and stumbledelay2 <= 0 then
			if stumble > -8 then
			stumble = stumble + -4
				stumbledelay2 = stumblemax
			end
		end
		if pad:left() and stumbledelay2 <= 0 then
			if stumble > -8 then
			stumble = stumble + -4
				stumbledelay2 = stumblemax
			end
		end
		if pad:right() and stumbledelay2 <= 0 then
			if stumble < 8 then
				stumble = stumble + 4
				stumbledelay2 = stumblemax
			end
		end
		if pad:select() then
			screen:save("bonus2.png")
		end
		stumbledelay2 = stumbledelay2 - 1
	end
end
--***************************Main*********************************************
bg2intro()
hi_score = 0
loadb2graphics()
while bg2endtest ~= 2 do
	initvalues()
	playbonus2()
end
bg2endtest = 0
unloadb2graphics()
unloadfunctions()
unloadfunctions = null