System.setCpuSpeedHigh() --Sets CPU to 333 Mhz

--emptyram = System.getFreeMemory() --Base value to monitor RAM used

--colors
black = Color.new(0,0,0)
white = Color.new(255,255,255)
pink = Color.new(255, 0 , 153)

loadscreen = Image.load("images/menu/loadscreen.png")
ssheetlower = Image.load("images/score/ssheetlower.png")
ssheetnum = Image.load("images/score/ssheetnum.png")
num = ssheetnum
ssheetupper = Image.load("images/score/ssheetupper.png")
ssheettracker = Image.load("images/score/ssheettracker.png")

dofile("enterHS.lua")
gamevolume = 80
introvolume = 25
Music.volume(gamevolume)

highscores = {}
for i=1,5 do
	highscores[i] = {}
	highscores[i][1] = 0
	highscores[i][2] = 0
end

function loadgamegraphics()
	fadein(loadscreen, 30, 0)
	
	wall_h = Sound.load("sounds/wall_h.wav")
	block_h = Sound.load("sounds/block_h.wav")
			
	rndm = math.random(1,7)
	background = null
	background = Image.load("images/backgrounds/bg" .. rndm .. ".png")

	exp1 = Image.load("images/bosses/exp1.png")
	exp2 = Image.load("images/bosses/exp2.png")
	exp3 = Image.load("images/bosses/exp3.png")

	paddle1 = Image.load("images/paddles/paddle1.png")
	paddle2 = Image.load("images/paddles/paddle2.png")
	paddle3 = Image.load("images/paddles/paddle3.png")
	paddle4 = Image.load("images/paddles/paddle4.png")

	xpaddle1 = Image.load("images/paddles/xpaddle1.png")
	xpaddle2 = Image.load("images/paddles/xpaddle2.png")
	xpaddle3 = Image.load("images/paddles/xpaddle3.png")
	xpaddle4 = Image.load("images/paddles/xpaddle4.png")

	paddlemorph1 = Image.load("images/paddles/paddlemorph1.png")
	paddlemorph2 = Image.load("images/paddles/paddlemorph2.png")
	paddlemorph3 = Image.load("images/paddles/paddlemorph3.png")
	paddlemorph4 = Image.load("images/paddles/paddlemorph4.png")

	ball = Image.load("images/misc/ball.png")
	curve_meter = Image.load("images/misc/curve_meter.png")
	curve_meter_marker = Image.load("images/misc/curve_meter_marker.png")

	scroll_main = Image.load("images/blocks/scroll_main.png")
	scroll_blue = Image.load("images/blocks/scroll_blue.png")
	scroll_green = Image.load("images/blocks/scroll_green.png")
	scroll_orange = Image.load("images/blocks/scroll_orange.png")
	scroll_purple = Image.load("images/blocks/scroll_purple.png")
	scroll_red = Image.load("images/blocks/scroll_red.png")
	scroll_golden_1 = Image.load("images/blocks/scroll_golden_1.png")
	scroll_golden_2 = Image.load("images/blocks/scroll_golden_2.png")

	block10x70 = Image.load("images/blocks/block10x70.png")
	block20x20 = Image.load("images/blocks/block20x20.png")
	block25x25 = Image.load("images/blocks/block25x25.png")
	block25x100 = Image.load("images/blocks/block25x100.png")
	block30x30 = Image.load("images/blocks/block30x30.png")
	block35x10 = Image.load("images/blocks/block35x10.png")
	block35x35 = Image.load("images/blocks/block35x35.png")
	block35x50 = Image.load("images/blocks/block35x50.png")
	block40x40 = Image.load("images/blocks/block40x40.png")
	block45x45 = Image.load("images/blocks/block45x45.png")
	block50x50 = Image.load("images/blocks/block50x50.png")
	block70x20 = Image.load("images/blocks/block70x20.png")
	block105x10 = Image.load("images/blocks/block105x10.png")
	block105x50 = Image.load("images/blocks/block105x50.png")

	torch1 = Image.load("images/torches/torch1.png")
	torch2 = Image.load("images/torches/torch2.png")
	torch3 = Image.load("images/torches/torch3.png")
	torch4 = Image.load("images/torches/torch4.png")
	torch5 = Image.load("images/torches/torch5.png")

	powerupextend = Image.load("images/powerups/powerup_extension.png")
	powerupcurve = Image.load("images/powerups/powerup_curve.png")
	poweruppaddle_f = Image.load("images/powerups/powerup_paddle_fast.png")
	poweruppaddle_s = Image.load("images/powerups/powerup_paddle_slow.png")
	poweruptime_f = Image.load("images/powerups/powerup_time_fast.png")
	poweruptime_s = Image.load("images/powerups/powerup_time_slow.png")
	powerupstickyball = Image.load("images/powerups/powerup_stickyball.png")

	rep_extension = Image.load("images/powerups/rep_extension.png")
	rep_extension_g = Image.load("images/powerups/rep_extension_g.png")
	rep_curve = Image.load("images/powerups/rep_curve.png")
	rep_curve_g = Image.load("images/powerups/rep_curve_g.png")
	rep_paddle_slow = Image.load("images/powerups/rep_paddle_slow.png")
	rep_paddle_slow_g = Image.load("images/powerups/rep_paddle_slow_g.png")
	rep_paddle_speed = Image.load("images/powerups/rep_paddle_speed.png")
	rep_paddle_speed_g = Image.load("images/powerups/rep_paddle_speed_g.png")
	rep_sticky = Image.load("images/powerups/rep_sticky.png")
	rep_sticky_g = Image.load("images/powerups/rep_sticky_g.png")
	rep_time_slow = Image.load("images/powerups/rep_time_slow.png")
	rep_time_slow_g = Image.load("images/powerups/rep_time_slow_g.png")
	rep_time_speed = Image.load("images/powerups/rep_time_speed.png")
	rep_time_speed_g = Image.load("images/powerups/rep_time_speed_g.png")

	pausescreen = Image.load("images/pausemenu/pausescreen.png")
	pmain_b = Image.load("images/pausemenu/mainmenu_b.png")
	pmain_r = Image.load("images/pausemenu/mainmenu_r.png")
	presume_b = Image.load("images/pausemenu/resume_b.png")
	presume_r = Image.load("images/pausemenu/resume_r.png")

	gameover = Image.load("images/score/gameover.png")
	xtorespawn = Image.load("images/score/xtorespawn.png")
	locked = Image.load("images/score/locked.png")
	minigameunlocked = Image.load("images/score/minigameunlocked.png")

	lc1 = Image.load("images/victory/levelcomplete1.png")
	lc2 = Image.load("images/victory/levelcomplete2.png")
	lc3 = Image.load("images/victory/levelcomplete3.png")
	curvebonus_r = Image.load("images/victory/curvebonus_r.png")
	finalscore_r = Image.load("images/victory/finalscore_r.png")
	level_r = Image.load("images/victory/level_r.png")
	mgoodscore = Image.load("images/score/mgoodscore.png")
	fadeout(loadscreen, 30, 0)
end

function unloadgamegraphics()
	unloadgamevars()
	blocklist = {}
	blocklist[1] = null
	powerupq = null
	boss2missles = null
	dropgrid = null
	wall_h = null
	block_h = null
	sebosshit = null
	semissledrop = null
	semisslelaunch = null
	background = null

	firstboss1 = null
	firstboss2 = null
	firstboss3 = null

	firstboss2b = null
	firstboss3b = null
	bomb = null

	exp1 = null
	exp2 = null
	exp3 = null

	paddle1 = null
	paddle2 = null
	paddle3 = null
	paddle4 = null

	xpaddle1 = null
	xpaddle2 = null
	xpaddle3 = null
	xpaddle4 = null

	paddlemorph1 = null
	paddlemorph2 = null
	paddlemorph3 = null
	paddlemorph4 = null

	ball = null
	curve_meter = null
	curve_meter_marker = null

	scroll_main = null
	scroll_main_bk = null
	scroll_blue = null
	scroll_blue_bk = null
	scroll_green = null
	scroll_green_bk = null
	scroll_orange = null
	scroll_orange_bk = null
	scroll_purple = null
	scroll_purple_bk = null
	scroll_red = null
	scroll_red_bk = null
	scroll_golden_1 = null
	scroll_golden_2 = null
	scroll_golden_bk = null

	block10x70 = null
	block20x20 = null
	block25x25 = null
	block25x100 = null
	block30x30 = null
	block35x10 = null
	block35x35 = null
	block35x50 = null
	block40x40 = null
	block45x45 = null
	block50x50 = null
	block70x20 = null
	block105x10 = null
	block105x50 = null

	torch1 = null
	torch2 = null
	torch3 = null
	torch4 = null
	torch5 = null

	powerupextend = null
	powerupcurve = null
	poweruppaddle_f = null
	poweruppaddle_s = null
	poweruptime_f = null
	poweruptime_s = null
	powerupstickyball = null

	rep_extension = null
	rep_extension_g = null
	rep_curve = null
	rep_curve_g = null
	rep_paddle_slow = null
	rep_paddle_slow_g = null
	rep_paddle_speed = null
	rep_paddle_speed_g = null
	rep_sticky = null
	rep_sticky_g = null
	rep_time_slow = null
	rep_time_slow_g = null
	rep_time_speed = null
	rep_time_speed_g = null

	pausescreen = null
	pmain_b = null
	pmain_r = null
	presume_b = null
	presume_r = null

	gameover = null
	xtorespawn = null
	locked = null
	minigameunlocked = null

	lc1 = null
	lc2 = null
	lc3 = null
	curvebonus_r = null
	finalscore = null
	level_r = null
	mgoodscore = null

	firstboss1 = null
	firstboss2 = null
	firstboss3 = null
	firstboss2b = null
	firstboss3b = null
	bomb = null

	twoboss1 = null
	twoboss1h = null
	twoboss2 = null
	twobossf1 = null
	twobossf2 = null
	bossbg1 = null
	water = null
	upm1 = null
	upm2 = null
	downm1 = null
	downm2 = null
	torches = null
	collectgarbage()
end

function unloadgamevars()
lifeCounter = null
torchOffset = null
tempTorchFrame = null
torchFrame = null
torchDelay = null
curve_time = null
curve_max = null
file = null
bossattack = null
bosstrack = null
bossState = null
bossdelaymax = null
bossdelay = null
bossWidth = null
bossmotion = null
damagedisplaytimer = null
bossArray = null
bossdiff = null
bosstime = null
bossattack = null
bossfire = null
surface = null
dropgrid = null
boss2missles = null
coll_ballx = null
coll_bally = null
coll_oldballx = null
coll_oldbally = null
n = null
emptytest = null
hit = null
powerup = null
poweruptype = null
powerupcount = null
cc = null
x_motion = null
y_motion = null
bodyx1 = null
bodyx2 = null
bodyy1 = null
bodyy2 = null
wingx1 = null
wingx2 = null
wingy1 = null
wingy2 = null
paddle_x = null
mtest = null
paddlestate = null
paddlestatedelay = null
currentpoweruptype = null
currentpoweruptimer = null
poweruptimermax = null
paddle_width = null
paddlestate = null
poweruppaddlemod = null
bspeedMod = null
stickypower = null
wall_hit = null
end

function loadintrographics()
	Music.volume(introvolume)
	fadein(loadscreen, 30, 0)
	pxp = Image.load("images/pxp.png")
	cnclogo = Image.load("images/cc.png")

	idiag1 = Sound.load("sounds/introscene1.wav")
	idiag2 = Sound.load("sounds/introscene2.wav")
	idiag3 = Sound.load("sounds/introscene3.wav")
	idiag4 = Sound.load("sounds/introscene4.wav")
	idiag5 = Sound.load("sounds/introscene5.wav")

	story1 = Image.load("images/intro/story1.png")
	story2 = Image.load("images/intro/story2.png")
	story3 = Image.load("images/intro/story3.png")
	story4 = Image.load("images/intro/story4.png")
	story5 = Image.load("images/intro/story5.png")
	story6 = Image.load("images/intro/story6.png")
	story7 = Image.load("images/intro/story7.png")
	story8 = Image.load("images/intro/story8.png")
	story9 = Image.load("images/intro/story9.png")
	fadeout(loadscreen, 30, 0)
end


function unloadtitlebg()
	titlebg1 = null
	titlebg2 = null
	titlebg3 = null
	titlebg4 = null
	titlebg5 = null
	titlebg6 = null
	collectgarbage()
end

function unloadintrographics()
	cnclogo = null
	pxp = null

	idiag1 = null
	idiag2 = null
	idiag3 = null
	idiag4 = null
	idiag5 = null

	story1 = null
	story2 = null
	story3 = null
	story4 = null
	story5 = null
	story6 = null
	story7 = null
	story8 = null
	story9 = null
	collectgarbage()
end

function loadmenugraphics()
	fadein(loadscreen, 30, 0)
	menubg1 = Image.load("images/menu/menu1.png")
	menubg2 = Image.load("images/menu/menu2.png")
	menubg3 = Image.load("images/menu/menu3.png")
	menubg4 = Image.load("images/menu/menu4.png")
	menubg5 = Image.load("images/menu/menu5.png")
	menubg6 = Image.load("images/menu/menu6.png")

	diff = Image.load("images/menu/difficulty_r.png")

	app_b = Image.load("images/menu/app_b.png")
	master_b = Image.load("images/menu/master_b.png")
	scholar_b = Image.load("images/menu/scholar_b.png")
	curlevel_b = Image.load("images/menu/curlevel_b.png")
	exit_b = Image.load("images/menu/exit_b.png")
	levelb_b = Image.load("images/menu/level_b.png")
	option_b = Image.load("images/menu/option_b.png")
	rhs_b = Image.load("images/menu/rhs_b.png")
	start_b = Image.load("images/menu/start_b.png")
	minigame_b = Image.load("images/menu/minigame_b.png")
	done_b = Image.load("images/menu/done_b.png")
	backmenu_b = Image.load("images/menu/backmenu_b.png")
	playcustom_b = Image.load("images/menu/playcustom_b.png")
	waterwalk_b = Image.load("images/menu/waterwalk_b.png")
	flighttest_b = Image.load("images/menu/flighttest_b.png")

	app_r = Image.load("images/menu/app_r.png")
	master_r = Image.load("images/menu/master_r.png")
	scholar_r = Image.load("images/menu/scholar_r.png")
	curlevel_r = Image.load("images/menu/curlevel_r.png")
	exit_r = Image.load("images/menu/exit_r.png")
	levelb_r = Image.load("images/menu/level_r.png")
	option_r = Image.load("images/menu/option_r.png")
	rhs_r = Image.load("images/menu/rhs_r.png")
	start_r = Image.load("images/menu/start_r.png")
	minigame_r = Image.load("images/menu/minigame_r.png")
	done_r = Image.load("images/menu/done_r.png")
	backmenu_r = Image.load("images/menu/backmenu_r.png")
	playcustom_r = Image.load("images/menu/playcustom_r.png")
	waterwalk_r = Image.load("images/menu/waterwalk_r.png")
	flighttest_r = Image.load("images/menu/flighttest_r.png")
	locked = Image.load("images/score/locked.png")

	bhs = Image.load("images/score/bhs.png")

	Music.playFile("sounds/edymion3.xm", true )
	fadeout(loadscreen, 30, 0)

	menudelay = 5
	menuframe = 1
	local img2 = menubg1
	fadein(img2, 15, 0)
	while menuframe < 7 do
		screen.waitVblankStart(1)
		if menudelay == 0 then
			menuframe = menuframe + 1
			menudelay = 5
		end
		if menuframe == 2 then
			img2 = menubg2
		end
		if menuframe == 3 then
			img2 = menubg3
		end
		if menuframe == 4 then
			img2 = menubg4
		end
		if menuframe == 5 then
			img2 = menubg5
		end
		if menuframe == 6 then
			img2 = menubg6
		end
		menudelay = menudelay - 1
		screen:blit(0, 0, img2)
		screen.flip()
	end
	img2 = null
end

function unloadmenugraphics()
	menubg1 = null
	menubg2 = null
	menubg3 = null
	menubg4 = null
	menubg5 = null
	menubg6 = null

	diff = null

	app_b = null
	master_b = null
	scholar_b = null
	curlevel_b = null
	exit_b = null
	level_b = null
	option_b = null
	rhs_b = null
	start_b = null
	done_b = null
	backmenu_b = null
	playcustom_b = null
	waterwalk_b = null
	flighttest_b = null

	app_r = null
	master_r = null
	scholar_r = null
	curlevel_r = null
	exit_r = null
	level_r = null
	option_r = null
	rhs_r = null
	start_r = null
	done_r = null
	backmenu_r = null
	playcustom_r = null
	waterwalk_r = null
	flighttest_r = null
	locked = null

	bhs = null
	dRep_b = null
	dRep_r = null
	collectgarbage()
end

function loadoutro()
	fadein(loadscreen, 30, 0)
	frame1 = Image.load("images/outro/outrof1.png")
	frame2 = Image.load("images/outro/outrof2.png")
	frame3 = Image.load("images/outro/outrof3.png")
	frame4 = Image.load("images/outro/outrof4.png")
	outro1 = Sound.load("sounds/outro1.wav")
	outro2 = Sound.load("sounds/outro2.wav")
	outro3 = Sound.load("sounds/outro3.wav")
	outro4 = Sound.load("sounds/outro4.wav")
	outro5 = Sound.load("sounds/outro5.wav")
	outro6 = Sound.load("sounds/outro6.wav")
	fadeout(loadscreen, 30, 0)
end

function unloadoutro()
	frame1 = null
	frame2 = null
	frame3 = null
	frame4 = null
	frame5 = null
	frame6 = null
	frame7 = null
	frame8 = null
	frame9 = null
	frame10 = null
	frame11 = null
	frame12 = null
	frame13 = null
	frame14 = null
	outro1 = null
	outro2 = null
	outro3 = null
	outro4 = null
	outro5 = null
	outro6 = null
	collectgarbage()
end

function outro()
	skip = 0
	loadoutro()
	Music.volume(introvolume)
	Music.playFile("sounds/d0xeh.mod", true )

	outro1:play()
	fadein(frame1, 15, skip)
	movieskip(skip, 180)
	fadeout(frame1, 15, skip)

	frame1 = null
	outro1 = null
	frame5 = Image.load("images/outro/outrof5.png")
	if skip == 0 then
		outro2:play()
	end
	fadein(frame2, 15, skip)
	movieskip(skip, 150)
	fadeout(frame2, 15, skip)

	frame2 = null
	frame6 = Image.load("images/outro/outrof6.png")
	if skip == 0 then
		outro3:play()
	end
	fadein(frame3, 15, skip)
	movieskip(skip, 120)
	fadeout(frame3, 15, skip)

	frame3 = null
	frame7 = Image.load("images/outro/outrof7.png")
	fadein(frame4, 15, skip)
	movieskip(skip, 180)
	fadeout(frame4, 15, skip)

	frame4 = null
	frame8 = Image.load("images/outro/pacocredit.png")
	if skip == 0 then
		outro4:play()
	end
	fadein(frame5, 15, skip)
	movieskip(skip, 180)
	fadeout(frame5, 15, skip)

	frame5 = null
	frame9 = Image.load("images/outro/robcredit.png")
	if skip == 0 then
		outro5:play()
	end
	fadein(frame6, 15, skip)
	movieskip(skip, 180)
	fadeout(frame6, 15, skip)

	frame6 = null
	frame10 = Image.load("images/outro/stephcredit.png")
	if skip == 0 then
		outro6:play()
	end
	fadein(frame7, 15, skip)
	movieskip(skip, 360)
	fadeout(frame7, 15, skip)

	frame7 = null
	frame11 = Image.load("images/outro/jovcredit.png")
	Music.volume(gamevolume)
	Music.playFile("sounds/doskpop.mod", true )
	fadein(frame8, 15, 0)
	screen.waitVblankStart(180)
	fadeout(frame8, 15, 0)

	frame8 = null
	frame12 = Image.load("images/outro/willcredit.png")
	fadein(frame9, 15, 0)
	screen.waitVblankStart(180)
	fadeout(frame9, 15, 0)

	frame9 = null
	frame13 = Image.load("images/outro/kylecredit.png")
	fadein(frame10, 15, 0)
	screen.waitVblankStart(180)
	fadeout(frame10, 15, 0)

	frame10 = null
	frame14 = Image.load("images/outro/finalcredit.png")
	fadein(frame11, 15, 0)
	screen.waitVblankStart(180)
	fadeout(frame11, 15, 0)

	fadein(frame12, 15, 0)
	screen.waitVblankStart(180)
	fadeout(frame12, 15, 0)

	fadein(frame13, 15, 0)
	screen.waitVblankStart(180)
	fadeout(frame13, 15, 0)

	fadein(frame14, 15, 0)
	while true do
		pad = Controls.read()
		if pad:cross() then
			while pad:cross() do
				pad = Controls.read()
			end
			break
		end
	end
	fadeout(frame14, 15, skip)
	unloadoutro()
end

function loadboss1intro()
	fadein(loadscreen, 30, 0)
	frame1 = Image.load("images/bosses/boss1story/frame1.png")
	frame2 = Image.load("images/bosses/boss1story/frame2.png")
	frame3 = Image.load("images/bosses/boss1story/frame3.png")
	frame4 = Image.load("images/bosses/boss1story/frame4.png")
	fadeout(loadscreen, 30, 0)
end

function unloadboss1intro()
	frame1 = null
	frame2 = null
	frame3 = null
	frame4 = null
	frame5 = null
	frame6 = null
	frame7 = null
	collectgarbage()
end

function boss1intro()
	skip = 0
	loadboss1intro()
	Music.playFile("sounds/d0xeh.mod", true )

	fadein(frame1, 15, skip)
	movieskip(skip, 180)
	fadeout(frame1, 15, skip)

	frame1 = null
	frame5 = Image.load("images/bosses/boss1story/frame5.png")
	fadein(frame2, 15, skip)
	movieskip(skip, 180)
	fadeout(frame2, 15, skip)

	frame2 = null
	frame6 = Image.load("images/bosses/boss1story/frame6.png")
	fadein(frame3, 15, skip)
	movieskip(skip, 180)
	fadeout(frame3, 15, skip)

	frame3 = null
	frame7 = Image.load("images/bosses/boss1story/frame7.png")
	fadein(frame4, 15, skip)
	movieskip(skip, 180)
	fadeout(frame4, 15, skip)

	fadein(frame5, 15, skip)
	movieskip(skip, 180)
	fadeout(frame5, 15, skip)

	fadein(frame6, 15, skip)
	movieskip(skip, 180)
	fadeout(frame6, 15, skip)

	fadein(frame7, 15, skip)
	movieskip(skip, 180)
	fadeout(frame7, 15, skip)

	unloadboss1intro()
end

function loadboss2intro()
	fadein(loadscreen, 30, 0)
	frame1 = Image.load("images/bosses/boss2story/frame1.png")
	frame2 = Image.load("images/bosses/boss2story/frame2.png")
	frame3 = Image.load("images/bosses/boss2story/frame3.png")
	frame4 = Image.load("images/bosses/boss2story/frame4.png")
	fadeout(loadscreen, 30, 0)
end

function unloadboss2intro()
	frame1 = null
	frame2 = null
	frame3 = null
	frame4 = null
	frame5 = null
	frame6 = null
	frame7 = null
	frame8 = null
	collectgarbage()
end

function boss2intro()
	skip = 0
	loadboss2intro()
	Music.playFile("sounds/d0xeh.mod", true )

	fadein(frame1, 15, skip)
	movieskip(skip, 180)
	fadeout(frame1, 15, skip)

	frame1 = null
	frame5 = Image.load("images/bosses/boss2story/frame5.png")
	fadein(frame2, 15, skip)
	movieskip(skip, 180)
	fadeout(frame2, 15, skip)

	frame2 = null
	frame6 = Image.load("images/bosses/boss2story/frame6.png")
	fadein(frame3, 15, skip)
	movieskip(skip, 180)
	fadeout(frame3, 15, skip)

	frame3 = null
	frame7 = Image.load("images/bosses/boss2story/frame7.png")
	fadein(frame4, 15, skip)
	movieskip(skip, 180)
	fadeout(frame4, 15, skip)

	frame4 = null
	frame8 = Image.load("images/bosses/boss2story/frame8.png")
	fadein(frame5, 15, skip)
	movieskip(skip, 180)
	fadeout(frame5, 15, skip)

	fadein(frame6, 15, skip)
	movieskip(skip, 180)
	fadeout(frame6, 15, skip)

	fadein(frame7, 15, skip)
	movieskip(skip, 180)
	fadeout(frame7, 15, skip)

	fadein(frame8, 15, skip)
	movieskip(skip, 180)
	fadeout(frame8, 15, skip)

	unloadboss2intro()
end

function initmaingame()
	exptrack1 = null
	exptrack2 = null
	exptrack3 = null
	exittomenu = 0
	deadcheck = 0
	buildtest = 0
	paddle_x = 82
	paddle_y = 234
	paddle_width = 50
	ball_x = 82
	ball_y = 110
	x_motion = 2
	y_motion = 2
	torchFrame = 1
	torchDelay = 3
	torches = {}
	bspeedMod = 0
	pspeedMod = 0
	powerupq = {}
	powerupcount = 1
	poweruptimermax = 1800
	bosstrack = 1
	bossState = 1
	bossdelaymax = 5
	bossdelay = bossdelaymax
	bossWidth = 75
	bossmotion = 1
	damagedisplaytimer = 0
	bossArray = {x = 0, y = 0, life = 0}
	for i=1, 3 do
		torches[i] = {}
		torches[i][1] = torch1
		torches[i][2] = torch2
		torches[i][3] = torch3
		torches[i][4] = torch4
		torches[i][5] = torch5
	end


	--***************Set Game Boundaries**************
	left = 24
	top = 24
	right = 288
	bottom = 248
	--************************************************
end

--***********************HIGHSCORES*******************
function saveHighscore()
	file = io.open("highscoreFile", "w")
	if file then
		for i=1,5 do
			file:write(highscores[i][1], " ")
			file:write(highscores[i][2], " ")
		end
		file:close()
	end
end
 
function loadHighscore()
	file = io.open("highscoreFile", "r")
	if file then
		for i=1, 5 do
			highscores[i][1] = file:read(3)
			highscores[i][2] = file:read("*n")
			local dump = file:read(1)
		end
		file:close()
		high = highscores[1][2]
		dump = null
	end
	for i=1,5 do
		if highscores[i][1] == null then
			highscores[i][1] = 0
		end
		if highscores[i][2] == null then
			highscores[i][2] = 0
		end
	end
	if high == null then
		high = 0
	end
end

function savegamedata()
	file = io.open("gamedata", "w")
	if file then
		file:write(gamedata.levelunlocked .. " ")
		file:write(gamedata.bgunlocked)
		file:close()
	end
end

function loadgamedata()
	gamedata = {}
	gamedata.levelunlocked = 1
	gamedata.bgunlocked = 0
	file = io.open("gamedata", "r")
	if file then
		tempdata = file:read("*n")
		if tempdata ~= null then
			gamedata.levelunlocked = tempdata
		end
		tempdata = file:read("*n")
		if tempdata ~= null then
			gamedata.bgunlocked = tempdata
		end
		file:close()
	end
end
--****************************************************
function explode(x, y)
	if exptrack1 == null then
		exptrack1 = 1
		expx1 = math.random(0,35)
		expy1 = math.random(0,1)
		expdelay1 = 0

		exptrack2 = 3
		expx2 = math.random(0,35)
		expy2 = math.random(0,1)
		expdelay2 = 0

		exptrack3 = 2
		expx3 = math.random(0,35)
		expy3 = math.random(0,1)
		expdelay3 = 0
	end
	if expdelay1 == 0 then
		if exptrack1 == 1 then
			expimage1 = exp1
		end
		if exptrack1 == 2 then
			expimage1 = exp2
		end
		if exptrack1 == 3 then
			expimage1 = exp3
			exptrack1 = 1
			expx1 = math.random(0,35)
			expy1 = math.random(0,1)
		end
		expdelay1 = math.random(4,6)
		exptrack1 = exptrack1 + 1
	else
		expdelay1 = expdelay1 - 1
	end
	if expdelay2 == 0 then
		if exptrack2 == 1 then
			expimage2 = exp1
		end
		if exptrack2 == 2 then
			expimage2 = exp2
		end
		if exptrack2 == 3 then
			expimage2 = exp3
			exptrack2 = 1
			expx2 = math.random(0,35)
			expy2 = math.random(0,1)
		end
		expdelay2 = math.random(4,6)
		exptrack2 = exptrack2 + 1
	else
		expdelay2 = expdelay2 - 1
	end
	if expdelay3 == 0 then
		if exptrack3 == 1 then
			expimage3 = exp1
		end
		if exptrack3 == 2 then
			expimage3 = exp2
		end
		if exptrack3 == 3 then
			expimage3 = exp3
			exptrack3 = 1
			expx3 = math.random(0,35)
			expy3 = math.random(0,1)
		end
		expdelay3 = math.random(4,6)
		exptrack3 = exptrack3 + 1
	else
		expdelay3 = expdelay3 - 1
	end
	screen:blit(x+expx1, y+expy1, expimage1)
	screen:blit(x+expx2, y+expy2, expimage2)
	screen:blit(x+expx3, y+expy3, expimage3)
end

function intprint(x,y,n)
	local row = 1
	local col = n
	if n == 9 then
		row = 2
		col = 1
	end
	if n == 0 then
		row = 2
		col = 2
	end
	screen:blit(x, y, num, 72+((col-1)*36), 29+((row-1)*36), 25, 25, false)
end

function fadein(img, speed, s)
	local fader = Image.createEmpty(120,68)
	local alpha = 255
	while alpha > 0 and s == 0 do
		fadeColor = Color.new(0,0,0,alpha)
		screen.waitVblankStart(1)
		fader:clear(fadeColor)
		screen:blit(0, 0, img)
		for i = 0, 3 do
			for j = 0, 3 do
				screen:blit(i*120, j*68, fader)
			end
		end
		screen.flip()
		alpha = alpha - speed
		if alpha < 0 then
			alpha = 0
		end

		pad = Controls.read()
		fadeColor = Color.new(0,0,0,alpha)
		fader:clear(fadeColor)
		screen:blit(0, 0, img)
		for i = 0, 3 do
			for j = 0, 3 do
				screen:blit(i*120, j*68, fader)
			end
		end
		screen.flip()
	end
	fader = null
	alpha = null
	fadeColor = null
end

function fadeout(img, speed, s)
	local fader = Image.createEmpty(120,68)
	local alpha = 0
	while alpha < 255 and s == 0 do
		fadeColor = Color.new(0,0,0,alpha)
		screen.waitVblankStart(1)
		fader:clear(fadeColor)
		screen:blit(0, 0, img)
		for i = 0, 3 do
			for j = 0, 3 do
				screen:blit(i*120, j*68, fader)
			end
		end
		screen.flip()
		alpha = alpha + speed
		if alpha > 255 then
			alpha = 255
		end
		fadeColor = Color.new(0,0,0,alpha)
		fader:clear(fadeColor)
		screen:blit(0, 0, img)
		for i = 0, 3 do
			for j = 0, 3 do
				screen:blit(i*120, j*68, fader)
			end
		end
		screen.flip()
	end
	fader = null
	alpha = null
	fadeColor = null
end

function movieskip(s, delay)
	if s == 0 then
		for i = 1, delay do
			screen.waitVblankStart(1)
			pad = Controls.read()
			if pad:cross() then
				while pad:cross() do
					pad = Controls.read()
				end
				break
			end
			if pad:start() then
				skip = 1
				screen:clear()
				screen.flip()
				musicfadeout()
				Music.stop()
				Music.volume(gamevolume)
				break
			end
	end	end
end

function musicfadeout()
	vol = gamevolume
	while vol > 0 do
		Music.volume(vol)
		vol = vol - 3
	end
end

function intro()
	skip = 0
	fadedelay = 15

	loadintrographics()
	
	fadein(cnclogo, 15, 0)
	screen.waitVblankStart(120)
	fadeout(cnclogo, 15, 0)
	--codenconcept = null

	fadein(pxp, 15, 0)
	screen.waitVblankStart(120)
	fadeout(pxp, 15, 0)

	pxp = null
	Music.playFile("sounds/edymion1.xm", true )

	if skip == 0 then
		idiag1:play()
	end
	fadein(story1, fadedelay, skip)
	movieskip(skip, 280)
	fadeout(story1, fadedelay, skip)

	idiag1 = null
	story1 = null
	titlebg1 = Image.load("images/menu/title1.png")
	if skip == 0 then
		idiag2:play()
	end
	fadein(story2, fadedelay, skip)
	movieskip(skip, 280)
	fadeout(story2, fadedelay, skip)

	fadein(story3, fadedelay, skip)
	movieskip(skip, 100)
	fadeout(story3, fadedelay, skip)

	titlebg2 = Image.load("images/menu/title2.png")
	fadein(story4, fadedelay, skip)
	movieskip(skip, 120)
	fadeout(story4, fadedelay, skip)

	idiad2 = null
	story2 = null
	story3 = null
	story4 = null
	titlebg3 = Image.load("images/menu/title3.png")
	if skip == 0 then
		idiag3:play()
	end
	fadein(story5, fadedelay, skip)
	movieskip(skip, 280)
	fadeout(story5, fadedelay, skip)

	titlebg4 = Image.load("images/menu/title4.png")
	if skip == 0 then
		idiag4:play()
	end
	fadein(story6, fadedelay, skip)
	movieskip(skip, 280)
	fadeout(story6, fadedelay, skip)

	fadein(story7, fadedelay, skip)
	movieskip(skip, 280)
	fadeout(story7, fadedelay, skip)

	titlebg5 = Image.load("images/menu/title5.png")
	if skip == 0 then
		idiag5:play()
	end
	fadein(story8, fadedelay, skip)
	movieskip(skip, 200)
	fadeout(story8, fadedelay, skip)

	titlebg6 = Image.load("images/menu/title6.png")
	fadein(story9, fadedelay, skip)
	movieskip(skip, 300)
	fadeout(story9, fadedelay, skip)
	unloadintrographics()
	
	musicfadeout()
	Music.stop()
	Music.volume(gamevolume)

	Music.playFile("sounds/edymion12.it", true )
	titledelay = 5
	titleframe = 1
	local img = titlebg1
	fadein(img, 15, 0)
	while titleframe < 7 do
		screen.waitVblankStart(1)
		if titledelay == 0 then
			titleframe = titleframe + 1
			titledelay = 5
		end
		if titleframe == 2 then
			img = titlebg2
		end
		if titleframe == 3 then
			img = titlebg3
		end
		if titleframe == 4 then
			img = titlebg4
		end
		if titleframe == 5 then
			img = titlebg5
		end
		if titleframe == 6 then
			img = titlebg6
		end
		titledelay = titledelay - 1
		screen:blit(0, 0, img)
		screen.flip()
	end
	local startgame = 0
	while startgame == 0 do
		screen:blit(0, 0, img)
		screen:print(200, 252, "Press Start", white)
		screen.flip()
		pad = Controls.read()
		if pad:start() then
			while pad:start() do
				pad = Controls.read()
			end
			startgame = 1
		end
	end
	fadeout(img, 15, 0)
	img = null
	musicfadeout()
	Music.stop()
	Music.volume(gamevolume)
	unloadintrographics()
	unloadtitlebg()
end


function gameStatus()--*******************************
	screen:print(355, 45, "Score", white)
	screen:print(355, 55, newHigh, white)
	screen:print(355, 130, "High Score", white)
	screen:print(355, 140, high, white)
	lifeCounter = lives
	torchOffset = 0
	for i=1, 3 do --animates torches
		tempTorchFrame = torchFrame - i
		if tempTorchFrame <= 0 then
			tempTorchFrame = 4 + tempTorchFrame
		end
		if lifeCounter > 0 then
			screen:blit(352+torchOffset, 65, torches[i][tempTorchFrame])
		else
			screen:blit(352+torchOffset, 65, torches[i][5])
		end
		torchOffset = torchOffset + 20
		lifeCounter = lifeCounter - 1
	end
	if torchDelay > 0 then
		torchDelay = torchDelay - 1
	else
		if torchFrame == 4 then
			torchFrame = 1
		else
			torchFrame = torchFrame + 1
		end
		torchDelay = 3
	end
	
end


function menu () --******************************************
	loadmenugraphics()
	onebosslevel = 5
	twobosslevel = 11
	level = 1
	customlevel = 1
	difficulty = 0
	pad = Controls.read()
	while pad:cross() do
		pad = Controls.read()
	end

	loadHighscore()
	local x = 1					--tracks current menu item
	local tier = 1
	displaylevel1 = 0
	displaylevel2 = 0
	while true do
		if difficulty == 0 then			-- Displays choosen difficulty
			dRep_b = app_b
			dRep_r = app_r
		end
		if difficulty == 1 then
			dRep_b = scholar_b
			dRep_r = scholar_r
		end
		if difficulty == 2 then
			dRep_b = master_b
			dRep_r = master_r
		end
		if level < 10 then
			displaylevel1 = 0
			displaylevel2 = level
		else
			displaylevel1 = 1
			displaylevel2 = level - 10
		end
		screen:blit(0, 0, menubg6, false)
		if tier == 1 then
			if x == 1 then
				screen:blit(100, 60, start_b)
			else
				screen:blit(100, 60, start_r)
			end
			if x == 2 then
				screen:blit(100, 85, curlevel_b)
				if level < 10 then
					intprint(280,83,level)
				else
					intprint(280,83,displaylevel1)
					intprint(310,83,displaylevel2)
				end
			else
				screen:blit(100, 85, curlevel_r)
				if level < 10 then
					intprint(280,83,level)
				else
					intprint(280,83,displaylevel1)
					intprint(310,83,displaylevel2)
				end
			end
			if x == 3 then
				screen:blit(100, 110, option_b)
			else
				screen:blit(100, 110, option_r)
			end
			if x == 4 then
				screen:blit(100, 135, minigame_b)
			else
				screen:blit(100, 135, minigame_r)
			end
			if x == 5 then
				screen:blit(100, 160, exit_b)
			else
				screen:blit(100, 160, exit_r)
			end

		elseif tier == 2 then
			if x == 1 then
				screen:blit(100, 60, rhs_b)
			else
				screen:blit(100, 60, rhs_r)
			end
			if x == 2 then
				screen:blit(100, 85, diff)
				screen:blit(240, 85, dRep_b)
			else
				screen:blit(100, 85, diff)
				screen:blit(240, 85, dRep_r)
			end
			if x == 3 then
				screen:blit(100, 110, levelb_b)
			else
				screen:blit(100, 110, levelb_r)
			end
			if x == 4 then
				screen:blit(100, 135, playcustom_b)
				intprint(330,133,customlevel)
			else
				screen:blit(100, 135, playcustom_r)
				intprint(330,133,customlevel)
			end
			if x == 5 then
				screen:blit(100, 160, done_b)
			else
				screen:blit(100, 160, done_r)
			end
		elseif tier == 3 then
			if x == 1 then
				screen:blit(100, 60, flighttest_b)
			else
				screen:blit(100, 60, flighttest_r)
			end
			if x == 2 then
				screen:blit(100, 85, waterwalk_b)
			else
				screen:blit(100, 85, waterwalk_r)
			end
			if x == 3 then
				screen:blit(100, 110, backmenu_b)
			else
				screen:blit(100, 110, backmenu_r)
			end
		end

		--ram = math.floor((System.getFreeMemory()/emptyram)*100) --tracks memory used
		--screen:print(350, 10, "Free RAM = " .. ram .. "%", white)
		screen.flip()

		pad = Controls.read()
		if pad:up() then				--moves menu choice up with wrap around
			if x > 1 then
				x = x - 1
				screen.waitVblankStart(10)
			else
				if tier == 1 then
					x = 5
				elseif tier == 2 then
					x = 5
				elseif tier == 3 then
					x = 3
				end				
				screen.waitVblankStart(10)
			end
		end

		if pad:down() then				--moves menu choice down with wrap around
			if tier == 1 then
				if x < 5 then
					x = x + 1
				else
					x = 1
				end
				screen.waitVblankStart(10)
			elseif tier == 2 then
				if x < 5 then
					x = x + 1
				else
					x = 1
				end
				screen.waitVblankStart(10)
			elseif tier == 3 then
				if x < 3 then
					x = x + 1
				else
					x = 1
				end
				screen.waitVblankStart(10)
			end
		end
			
		if pad:cross() then
			while pad:cross() do
				pad = Controls.read()
			end
			if tier == 1 then
				if x == 1 then
					paddle_y = 234
					bottom = 248
					fadeout(menubg6, 15, 0)
					musicfadeout()
					Music.stop()
					Music.volume(gamevolume)
					unloadmenugraphics()
					loadHighscore()
					loadgamegraphics()
					initmaingame()
					buildlevel()
					if blocklist[1] ~= null or bossArray.life > 0 then
						newHigh = 0
						lives = 3
						paddleinitialize = 1
						play()
						torches = null
						blocklist = null
						unloadgamegraphics()
						loadmenugraphics()
					else
						screen:print(50, 50, "empty file", pink)
						screen.flip()
						screen.waitVblankStart(60)
					end
				end
				if x == 3 then
					tier = 2
					x = 1
				end
				if x == 4 then
					tier = 3
					x = 1
				end
				if x == 5 then
					fadeout(menubg6, 15, 0)
					musicfadeout()
					Music.stop()
					Music.volume(gamevolume)
					System.setCpuSpeedReg() --Sets CPU to 222 Mhz
					System.Quit()
				end
			elseif tier == 2 then
				if x == 1 then
					loadHighscore()

					screen:clear()
					screen:blit(0,0,bhs)
					for j=1,5 do
						if highscores[j][1] ~= null then
							printchar(100,45 + (j*25), string.sub(highscores[j][1],1,1))
							printchar(125,45 + (j*25), string.sub(highscores[j][1],2,2))
							printchar(150,45 + (j*25), string.sub(highscores[j][1],3,3))
						end
						if highscores[j][2] ~= null then
							scoreconvert(highscores[j][2])
							i = 1
							while scorearray[i+1] ~= null do
								i = i + 1
							end
							for ii = 1,  i do
								intprint(180+(175-(i*25))+(ii*25),45 + (j*25),scorearray[ii])
							end
						end
					end
					screen.flip()
					while true do
						pad = Controls.read()
						if pad:circle() then
							while pad:circle() do
								pad = Controls.read()
							end
							break
						end
						screen.waitVblankStart(1)
					end
				end
				if x == 3 then
					fadeout(menubg6, 15, 0)
					musicfadeout()
					Music.stop()
					Music.volume(gamevolume)
					unloadmenugraphics()
					bg = Image.load("images/backgrounds/build_bg.png")
					dot = Image.load("images/misc/dot.png")
					loadgamegraphics()
					initmaingame()
					newHigh = 0
					customplay = 1
					x = left + 1
					y = top + 1
					movespeed = 3
					blocklist = {}
					item = 1
					c = 1
					blocklist[item] = {}
					blocklist[item][1] = x
					blocklist[item][2] = y
					blocklist[item][3] = scroll_main
					blocklist[item][4] = 1
					blocklist[item][9] = 1
					blocklist[item][10] = 35
					blocklist[item][11] = 10
					blocklist[item][12] = 1
				
					musicfadeout()
					Music.stop()
					Music.volume(gamevolume)
					Music.playFile("sounds/d0xeh.mod", true )
					buildcustomlevel()
					unloadgamegraphics()
					x = 1
					blocklist = null
					bg = null
					dot = null
					level = 1
					customplay = 0
					collectgarbage()
					loadmenugraphics()
				end
				if x == 4 then
					customplay = 1
					level = 1
					paddle_y = 234
					bottom = 248
					fadeout(menubg6, 15, 0)
					musicfadeout()
					Music.stop()
					Music.volume(gamevolume)
					unloadmenugraphics()
					loadHighscore()
					loadgamegraphics()
					initmaingame()
					buildlevel()
					if blocklist[1] ~= null or bossArray.life > 0 then
						newHigh = 0
						lives = 3
						paddleinitialize = 1
						play()
						torches = null
						blocklist = null
						unloadgamegraphics()
						collectgarbage()
						loadmenugraphics()
					else
						screen:print(50, 50, "empty file", pink)
						screen.flip()
						screen.waitVblankStart(60)
					end
					customplay = 0
				end
				if x == 5 then
					tier = 1
					x = 1
				end
			elseif tier == 3 then
				if x == 1 and gamedata.bgunlocked >= 1 then
					fadeout(menubg6, 15, 0)
					musicfadeout()
					Music.stop()
					Music.volume(gamevolume)
					unloadmenugraphics()
					dofile("bonusgame1.lua")
					loadmenugraphics()
				elseif x == 1 then
					screen:blit(270, 60, locked)
					screen.flip()
					screen.waitVblankStart(60)
				end
				if x == 2 and gamedata.bgunlocked >= 2 then
					fadeout(menubg6, 15, 0)
					musicfadeout()
					Music.stop()
					Music.volume(gamevolume)
					unloadmenugraphics()
					dofile("bonusgame2.lua")
					loadmenugraphics()
				elseif x == 2 then
					screen:blit(270, 85, locked)
					screen.flip()
					screen.waitVblankStart(60)
				end
				if x == 3 then
					tier = 1
					x = 1
				end
        		end
		end
		if pad:left() then
			if tier == 1 then
				if x == 2 then
					if level ~= 1 then
						level = level - 1
					end
					screen.waitVblankStart(10)
				end
			elseif tier == 2 then
				if x == 2 then
					if difficulty ~= 0 then
						difficulty = difficulty - 1
					end
					screen.waitVblankStart(10)
				end
				if x == 4 then
					if customlevel ~= 1 then
						customlevel = customlevel - 1
					end
					screen.waitVblankStart(10)
				end
			end
		end

		if pad:right() then
			if tier == 1 then
				if x == 2 then
					if level ~= gamedata.levelunlocked then
						level = level + 1
					end
					screen.waitVblankStart(10)
				end
			elseif tier == 2 then
				if x == 2 then
					if difficulty ~= 2 then
						difficulty = difficulty + 1
					end
					screen.waitVblankStart(10)
				end
				if x == 4 then
					if customlevel ~= 9 then
						customlevel = customlevel + 1
					end
					screen.waitVblankStart(10)
				end
			end
		end
	end
end

function pause () --*****************************************
	while pad:start() do
		pad = Controls.read()
	end
	local x = 1
	while true do
		screen:blit(106, 72, pausescreen)
		if x == 1 then
			screen:blit(200, 120, presume_b)
			screen:blit(200, 140, pmain_r)
		else
			screen:blit(200, 120, presume_r)
			screen:blit(200, 140, pmain_b)
		end
		screen.flip()
		screen.waitVblankStart(1)
		pad = Controls.read()
		if pad:start() then
			while pad:start() do
				pad = Controls.read()
			end
                	break
        	end
		if pad:up() then
			if x == 1 then
				x = 2
			else
				x = 1
			end
			screen.waitVblankStart(10)
		end
		if pad:down() then
			if x == 1 then
				x = 2
			else
				x = 1
			end
			screen.waitVblankStart(10)
		end
		if pad:cross() then
			if x == 1 then
				break
			else
				exittomenu = 1
				musicfadeout()
				Music.stop()
				Music.volume(gamevolume)
				break
			end
			screen.waitVblankStart(10)
		end
	end
end

function scoreconvert(cs)
	scorearray = {}
	local tempnum = 0
	local tempscore = cs
	local temptrack = 1
	if tempscore >= 100000 then
		while tempscore >= 100000 do
			tempnum = tempnum + 1
			tempscore = tempscore - 100000
		end
		scorearray[temptrack] = tempnum
		temptrack = temptrack + 1
		tempnum = 0
	end
	if tempscore >= 10000 or temptrack > 1 then
		while tempscore >= 10000 do
			tempnum = tempnum + 1
			tempscore = tempscore - 10000
		end
		scorearray[temptrack] = tempnum
		temptrack = temptrack + 1
		tempnum = 0
	end
	if tempscore >= 1000 or temptrack > 1 then
		while tempscore >= 1000 do
			tempnum = tempnum + 1
			tempscore = tempscore - 1000
		end
		scorearray[temptrack] = tempnum
		temptrack = temptrack + 1
		tempnum = 0
	end
	if tempscore >= 100 or temptrack > 1 then
		while tempscore >= 100 do
			tempnum = tempnum + 1
			tempscore = tempscore - 100
		end
		scorearray[temptrack] = tempnum
		temptrack = temptrack + 1
		tempnum = 0
	end
	if tempscore >= 10 or temptrack > 1 then
		while tempscore >= 10 do
			tempnum = tempnum + 1
			tempscore = tempscore - 10
		end
		scorearray[temptrack] = tempnum
		temptrack = temptrack + 1
		tempnum = 0
	end
	scorearray[temptrack] = tempscore
end

function victory () --***************************************
	powerupq = {}
	powerupcount = 1
	Music.stop()
	Music.playFile("sounds/doskpop.mod", true )
	local i = 480
	while i >= 80 do
		screen:blit(0, 0, background, false)
		gameStatus()
		screen:blit(i,120,lc1)
		screen.flip()
		screen.waitVblankStart(1)
		i = i - 40
	end

	screen:blit(0, 0, background, false)
	gameStatus()
	screen:blit(i,120,lc2)
	screen.flip()
	screen.waitVblankStart(1)
	ii = i
	for i=0,120 do
		screen:blit(0, 0, background, false)
		gameStatus()
		screen:blit(ii,120,lc3)
		screen.flip()
		screen.waitVblankStart(1)
		if ii < 70 then
			ii = ii + 1
		end
	end

	if level == onebosslevel or level == twobosslevel then	
		local i = 480
		while i >= 40 do
			screen:blit(0, 0, background, false)
			gameStatus()
			screen:blit(i,120,minigameunlocked)
			screen.flip()
			screen.waitVblankStart(1)
			i = i - 40
		end

		screen:blit(0, 0, background, false)
		gameStatus()
		screen:blit(i,120,minigameunlocked)
		screen.flip()
		screen.waitVblankStart(1)
		ii = i
		for i=0,120 do
			screen:blit(0, 0, background, false)
			gameStatus()
			screen:blit(ii,120,minigameunlocked)
			screen.flip()
			screen.waitVblankStart(1)
			if ii < 42 then
				ii = ii + 1
			end
		end
	end

	fadeout(background, 30, 0)
	fadein(mgoodscore, 30, 0)

	fdisscore = 0
	sctem = 100
	curvebonus = math.floor((5000*curve_time)/curve_max)
	oldhigh = newHigh
	newHigh = newHigh+curvebonus
	while true do
		screen:blit(0, 0, mgoodscore, false)

		screen:blit(70, 70, curvebonus_r)
		scoreconvert(curvebonus)
		i = 1
		while scorearray[i+1] ~= null do
			i = i + 1
		end
		for ii = 1,  i do
			intprint(70+(175-(i*25))+(ii*25),90,scorearray[ii])
		end
		
		screen:blit(70, 130, level_r)
		scoreconvert(oldhigh)
		i = 1
		while scorearray[i+1] ~= null do
			i = i + 1
		end
		for ii = 1,  i do
			intprint(70+(175-(i*25))+(ii*25),150,scorearray[ii])
		end

		screen:blit(70, 190, finalscore_r)
		scoreconvert(newHigh)
		i = 1
		while scorearray[i+1] ~= null do
			i = i + 1
		end
		for ii = 1,  i do
			intprint(70+(175-(i*25))+(ii*25),210,scorearray[ii])
		end
		screen.flip()
		screen.waitVblankStart(1)
		pad = Controls.read()
		if pad:cross() then
			while pad:cross() do
				pad = Controls.read()
			end
			rndm = math.random(1,7)
			background = null
			background = Image.load("images/backgrounds/bg" .. rndm .. ".png")
			musicfadeout()
			Music.stop()
			Music.volume(gamevolume)
			fadeout(mgoodscore, 30, 0)
			if level == -1 or customplay == 1 then
				v = true
				break
			end
			level = level + 1
			if gamedata.levelunlocked < level then
				gamedata.levelunlocked = level
			end
			if level <= twobosslevel then
				if level > onebosslevel then
					if gamedata.bgunlocked == 0 then
						gamedata.bgunlocked = 1
						savegamedata()
					end
				end
				initmaingame()
				buildlevel()
				paddleinitialize = 1
				play()
				break
			else
				gamedata.bgunlocked = 2
				gamedata.levelunlocked = twobosslevel
				level = 1
				mainhighscore()
				savegamedata()
				v = true
				unloadgamegraphics()
				outro()
				break
			end
        		end
	end
end

function mainhighscore()
	loadHighscore()
	for i = 1, 5 do
		if highscores[i][2] == null then
			highscores[i][2] = newHigh
			enterhighscore(i, highscores)
			saveHighscore()
			break
		end
		if newHigh > highscores[i][2] then
			if i < 5 then
				j = 5
				while j > i do
					highscores[j][1] = highscores[j-1][1]
					highscores[j][2] = highscores[j-1][2]
					j = j - 1
				end
			end
			highscores[i][2] = newHigh
			enterhighscore(i, highscores)
			saveHighscore()
			break
		end
	end
end

function death () --*****************************************
	powerupq = {}
	powerupcount = 1
	dtest = 0
	lives = lives - 1
	deadcheck = 1
	if lives == 0 then
		screen:blit(0, 0, background, false)
		gameStatus()
		screen:blit(90, 120, gameover)
		screen.flip()
		screen.waitVblankStart(120)
		if customplay == 0 then
			mainhighscore()
			savegamedata()
		end
		dtest = 1
		v = true
		loadHighscore()
		deadcheck = 0
		musicfadeout()
		Music.stop()
		Music.volume(gamevolume)
	end
	
	while dtest ~= 1 do
		ball_x = 0
		ball_y = 0
		test = 0
		screen:blit(0, 0, background, false)
		showlevel()
		gameStatus()
		screen:blit(70, 120, xtorespawn)
		screen.flip()
		pad = Controls.read()
		if pad:cross() then
			paddleinitialize = 1
			while pad:cross() do
				pad = Controls.read()
			end
			deadcheck = 0
			break
        	end
	end
end --*******************************************************

function curveTimeInit()
	if difficulty == 0 then
		curve_time = 1800
		curve_max = 1800
	end
	if difficulty == 1 then
		curve_time = 600
		curve_max = 600
	end
	if difficulty == 2 then
		curve_time = 300
		curve_max = 300
	end
end

function buildlevel () --************************************
v = false
if customplay == 1 then
	blocklist = {}
	curveTimeInit()
	file2 = io.open("customlevels/clevel"..customlevel, "r")
	if file2 then 
		temp = file2:read("*n")
		if temp == null then
			screen:print(50, 50, "empty file", pink)
			screen.flip()
			screen.waitVblankStart(60)
		else
			p = 1
			while temp ~= null do
				blocklist[p] = {}
				blocklist[p][1] = temp
				temp = file2:read("*n")
				blocklist[p][2] = temp
				temp = file2:read("*n")
				blocklist[p][4] = temp
				temp = file2:read("*n")
				blocklist[p][9] = temp
				temp = file2:read("*n")
				blocklist[p][10] = temp
				temp = file2:read("*n")
				blocklist[p][11] = temp
				temp = file2:read("*n")
				blocklist[p][12] = temp
				temp = file2:read("*n")
				p = p + 1
			end
		end
		file2:close()
	end
	repairlevel(blocklist)
	i = 1
	while blocklist[i] ~= null do
		blocklist[i][5] = blocklist[i][1] + (blocklist[i][1] + 5) - 10
		blocklist[i][6] = blocklist[i][2] + (blocklist[i][2] + 5) - 10
		blocklist[i][7] = blocklist[i][1] + blocklist[i][10] + (blocklist[i][1] + blocklist[i][10] + 5)
		blocklist[i][8] = blocklist[i][2] + blocklist[i][11] + (blocklist[i][2] + blocklist[i][11] + 5)
		i = i + 1
	end
	Music.playFile("sounds/d0xeh.mod", true )
else
if level == 1 then
	block_x = 28
	block_y = 50
	n = 1
	rowtrack = 1
	rowlength = 7
	curveTimeInit()
	blocklist = {}
	for n=1, 35 do
		blocklist[n] = {}
		blocklist[n][1] = block_x
		blocklist[n][2] = block_y
		blocklist[n][3] = scroll_main
		blocklist[n][4] = 1
		blocklist[n][9] = 1
		blocklist[n][10] = 35
		blocklist[n][11] = 10
		blocklist[n][12] = 1
		blocklist[n][5] = blocklist[n][1] + (blocklist[n][1] + 5) - 10
		blocklist[n][6] = blocklist[n][2] + (blocklist[n][2] + 5) - 10
		blocklist[n][7] = blocklist[n][1] + blocklist[n][10] + (blocklist[n][1] + blocklist[n][10] + 5)
		blocklist[n][8] = blocklist[n][2] + blocklist[n][11] + (blocklist[n][2] + blocklist[n][11] + 5)
		rowtrack = rowtrack + 1
		if rowtrack <= rowlength then
			block_x = block_x + 37
		else
			block_x = 28
			block_y = block_y + 13
			rowtrack = 1
		end
	end
	Music.playFile("sounds/d0xeh.mod", true )
end

if level ~= 1 and level <= twobosslevel then
	if level ~= onebosslevel and level ~= twobosslevel then
	blocklist = {}
	curveTimeInit()
	file = io.open("levels/level"..level, "r")
	if file then 
		temp = file:read("*n")
		if temp == null then
			screen:print(50, 50, "empty file", pink)
			screen.flip()
			screen.waitVblankStart(60)
		else
			p = 1
			while temp ~= null do
				blocklist[p] = {}
				blocklist[p][1] = temp
				temp = file:read("*n")
				blocklist[p][2] = temp
				temp = file:read("*n")
				blocklist[p][4] = temp
				temp = file:read("*n")
				blocklist[p][9] = temp
				temp = file:read("*n")
				blocklist[p][10] = temp
				temp = file:read("*n")
				blocklist[p][11] = temp
				temp = file:read("*n")
				blocklist[p][12] = temp
				temp = file:read("*n")
				p = p + 1
			end
		end
		file:close()
	end
	repairlevel(blocklist)
	i = 1
	while blocklist[i] ~= null do
		blocklist[i][5] = blocklist[i][1] + (blocklist[i][1] + 5) - 10
		blocklist[i][6] = blocklist[i][2] + (blocklist[i][2] + 5) - 10
		blocklist[i][7] = blocklist[i][1] + blocklist[i][10] + (blocklist[i][1] + blocklist[i][10] + 5)
		blocklist[i][8] = blocklist[i][2] + blocklist[i][11] + (blocklist[i][2] + blocklist[i][11] + 5)
		i = i + 1
	end
	Music.playFile("sounds/d0xeh.mod", true )
	end
end
end

if level == onebosslevel then
	boss1intro()
	firstboss1 = Image.load("images/bosses/firstboss1.png")
	firstboss2 = Image.load("images/bosses/firstboss2.png")
	firstboss3 = Image.load("images/bosses/firstboss3.png")
	firstboss2b = Image.load("images/bosses/firstboss2b.png")
	firstboss3b = Image.load("images/bosses/firstboss3b.png")
	bomb = Image.load("images/bosses/bomb.png")
	sebosshit = Sound.load("sounds/bosshit.wav")
	semissledrop = Sound.load("sounds/missledrop.wav")
	semisslelaunch = Sound.load("sounds/misslelaunch.wav")

	curveTimeInit()

	bosstrack = 1
	bossState = 1
	bossdelaymax = 5
	bossdelay = bossdelaymax
	bossWidth = 75
	bossmotion = 1
	damagedisplaytimer = 0
	bossArray = {x = 160, y = 30, life = 3}
	blocklist = {}
	blocklist[1] = null
	bossdiff = 1
	bossattack = 180
	powerupcount = 1
	powerupq = {}
	Music.playFile("sounds/0-bos15.xm", true )
end

if level == twobosslevel then
	boss2intro()
	paddle_y = paddle_y - 50
	bottom = bottom - 40
	twoboss1 = Image.load("images/bosses/2boss1.png")
	twoboss1h = Image.load("images/bosses/2boss1h.png")
	twoboss2 = Image.load("images/bosses/2boss2.png")
	twobossf1 = Image.load("images/bosses/2bossf1.png")
	twobossf2 = Image.load("images/bosses/2bossf2.png")
	bossbg1 = Image.load("images/bosses/bossbg1.png")
	water = Image.load("images/bosses/water.png")
	upm1 = Image.load("images/bosses/bombup1.png")
	upm2 = Image.load("images/bosses/bombup2.png")
	downm1 = Image.load("images/bosses/bombdown1.png")
	downm2 = Image.load("images/bosses/bombdown2.png")
	sebosshit = Sound.load("sounds/bosshit.wav")
	semissledrop = Sound.load("sounds/missledrop.wav")
	semisslelaunch = Sound.load("sounds/misslelaunch.wav")

	curveTimeInit()
	
	bossattack = 0
	bosstrack = 1
	bossState = 1
	bossdelaymax = 5
	bossdelay = bossdelaymax
	bossWidth = 75
	bossmotion = 1
	damagedisplaytimer = 0
	bossArray = {x = 160, y = 198, life = 3, w = 75}
	blocklist = {}
	blocklist[1] = null
	bossdiff = 1
	bosstime = 480
	bossattack = 0
	bossfire = 0
	surface = 0
	Music.playFile("sounds/0-bos15.xm", true )
end

end --********************************************************

function bosshit()
	sebosshit:play()
	if damagedisplaytimer < 1 then
		bossArray.life = bossArray.life - 1
		damagedisplaytimer = 60
		bossdiff = bossdiff + 1
	end
end

function animateBoss1()
	if bossdelay == 0 then
		bossState = bossState + bosstrack
		bossdelay = bossdelaymax
	else
		bossdelay = bossdelay - 1
	end

	bossArray.x = bossArray.x + bossmotion
	if bossArray.x > 290 - bossWidth then
		bossmotion = -1*bossdiff
	end
	if bossArray.x < 24 then
		bossmotion = 1*bossdiff
	end

	if damagedisplaytimer > 0 then
		if bossState == 1 then
			screen:blit(bossArray.x, bossArray.y, firstboss1)
			bosstrack = 1
			bossArray.y = bossArray.y + bossdiff
		elseif bossState == 2 then
			screen:blit(bossArray.x, bossArray.y, firstboss2b)
		elseif bossState == 3 then
			screen:blit(bossArray.x, bossArray.y, firstboss3b)
			bosstrack = -1
			bossArray.y = bossArray.y - bossdiff
		end
		damagedisplaytimer = damagedisplaytimer - 1
	else
		if bossState == 1 then
			screen:blit(bossArray.x, bossArray.y, firstboss1)
			bosstrack = 1
			bossArray.y = bossArray.y + bossdiff
		elseif bossState == 2 then
			screen:blit(bossArray.x, bossArray.y, firstboss2)
		elseif bossState == 3 then
			screen:blit(bossArray.x, bossArray.y, firstboss3)
			bosstrack = -1
			bossArray.y = bossArray.y - bossdiff
		end
	end

	if bossattack <= 0 and paddleinitialize ~= 1 and deadcheck ~= 1 then
		powerupq[powerupcount] = {}
		powerupq[powerupcount][1] = bossArray.x + 30
		powerupq[powerupcount][2] = bossArray.y + 37
		powerupq[powerupcount][3] = bomb
		powerupq[powerupcount][4] = 8
		powerupcount = powerupcount + 1
		bossattack = math.random(120-(45*(bossdiff-1)),160-(45*(bossdiff-1)))
	else
		bossattack = bossattack - 1
	end
end

function animateboss2()
	screen:blit(24, 21, bossbg1)

	if bosstime <= 0 then
		bossattack = 1
		bosstime = math.random(360,480)
	elseif bossattack == 0 and deadcheck == 0 then
		bosstime = bosstime - 1 - bossdiff
	end

	if bossdelay <= 0 and bossattack == 0 then
		bossState = bossState + bosstrack
		bossdelay = bossdelaymax
	else
		bossdelay = bossdelay - 1
	end

	if bossattack == 0 then --moves boss from side to side
		bossArray.x = bossArray.x + bossmotion
	end
	if bossArray.x > 290 - bossWidth then
		bossmotion = -1*bossdiff
	end
	if bossArray.x < 24 then
		bossmotion = 1*bossdiff
	end

	if damagedisplaytimer > 0 and bossattack == 0 then
		if bossState == 1 then
			screen:blit(bossArray.x, bossArray.y, twoboss1h) -- damaged boss
			bossArray.y = bossArray.y + 1
			bosstrack = 1
		elseif bossState == 2 then
			screen:blit(bossArray.x, bossArray.y, twoboss2) -- damaged boss frame 2
			bossArray.y = bossArray.y - 1
			bosstrack = -1
		end
		damagedisplaytimer = damagedisplaytimer - 1
	elseif bossattack == 0 then
		if bossState == 1 then
			screen:blit(bossArray.x, bossArray.y, twoboss1)
			bossArray.y = bossArray.y + 1
			bosstrack = 1
		elseif bossState == 2 then
			screen:blit(bossArray.x, bossArray.y, twoboss2)
			bossArray.y = bossArray.y - 1
			bosstrack = -1
		end
	end
	if bossattack == 1 then
		bossArray.y = bossArray.y - 1
		screen:blit(bossArray.x, bossArray.y, twoboss1)
		surface = surface + 1
		if surface == 15 then
			bossattack = 2
		end
	end
	if bossattack == 2 then
		if bossfire == 0 then
			boss2missles = {}
			boss2missles.m1x = bossArray.x + 17
			boss2missles.m1y = bossArray.y
			boss2missles.m1i = upm1
			boss2missles.m2x = bossArray.x + 17
			boss2missles.m2y = bossArray.y
			boss2missles.m2i = upm2
			boss2missles.m3x = bossArray.x + 17
			boss2missles.m3y = bossArray.y
			boss2missles.m3i = upm1
		end
		bossfire = bossfire + 1
		if bossfire >= 15 and bossfire < 18 then
			screen:blit(bossArray.x, bossArray.y, twobossf2)--***********
		elseif bossfire >= 18 and bossfire < 21 then
			screen:blit(bossArray.x, bossArray.y, twobossf1)--missle 1
			boss2missles.m1y = boss2missles.m1y - 1
			semisslelaunch:play()
		elseif bossfire >= 21 and bossfire < 24 then
			screen:blit(bossArray.x, bossArray.y, twobossf2)--***********
		elseif bossfire >= 30 and bossfire < 33 then
			screen:blit(bossArray.x, bossArray.y, twobossf2)--***********
		elseif bossfire >= 33 and bossfire < 36 then
			screen:blit(bossArray.x, bossArray.y, twobossf1)--missle 2
			boss2missles.m2y = boss2missles.m2y - 1
			semisslelaunch:play()
		elseif bossfire >= 36 and bossfire < 39 then
			screen:blit(bossArray.x, bossArray.y, twobossf2)--***********
		elseif bossfire >= 50 and bossfire < 53 then
			screen:blit(bossArray.x, bossArray.y, twobossf2)--***********
		elseif bossfire >= 53 and bossfire < 56 then
			screen:blit(bossArray.x, bossArray.y, twobossf1)--missle 3
			boss2missles.m3y = boss2missles.m3y - 1
			semisslelaunch:play()
		elseif bossfire >= 56 and bossfire < 59 then
			screen:blit(bossArray.x, bossArray.y, twobossf2)--***********
		else
			screen:blit(bossArray.x, bossArray.y, twoboss1)
		end
		if bossfire == 60 then
			bossattack = 3
			bossfire = 0
			boss2missleinit()
		end
	end
	if bossattack == 3 then
		bossArray.y = bossArray.y + 1
		if damagedisplaytimer > 0 then
			if bossState == 1 then
				screen:blit(bossArray.x, bossArray.y, twoboss1h)
			elseif bossState == 2 then
				screen:blit(bossArray.x, bossArray.y, twoboss1)
			end
		else
			screen:blit(bossArray.x, bossArray.y, twoboss1)
		end
		surface = surface - 1
		if surface == 0 then
			bossattack = 0
			bossArray.y = 198
			bossState = 1
			bosstrack = 1
		end
	end
	screen:blit(24, 21, water)
	if boss2missles ~= null then
		boss2misslefire()
	end
	if dropgrid ~= null then
		if bosstime < 300 and dropgrid.y1 == 20 then
			dropgrid.y1 = 22
			semissledrop:play()
		end
		if bosstime < 270 and dropgrid.y2 == 20 then
			dropgrid.y2 = 22
			semissledrop:play()
		end
		if bosstime < 240 and dropgrid.y3 == 20 then
			dropgrid.y3 = 22
			semissledrop:play()
		end
		if dropgrid.y1 ~= 20 and dropgrid.y1 < 250 then
			screen:blit(dropgrid.x1, dropgrid.y1, downm1)
			dropgrid.y1 = dropgrid.y1 + 3
		end
		if dropgrid.y2 ~= 20 and dropgrid.y2 < 250 then
			screen:blit(dropgrid.x2, dropgrid.y2, downm1)
			dropgrid.y2 = dropgrid.y2 + 3
		end
		if dropgrid.y3 ~= 20 and dropgrid.y3 < 250 then
			screen:blit(dropgrid.x3, dropgrid.y3, downm1)
			dropgrid.y3 = dropgrid.y3 + 3
		end
		if dropgrid.y3 > 250 then
			dropgrid = null
		end
		if dropgrid.y1 < 200 and dropgrid.y1 > 185 and dropgrid.x1 > paddle_x and dropgrid.x1 < (paddle_x + paddle_width) then
			dropgrid = null
			for i=1,60 do
				screen.waitVblankStart(1)
				screen:blit(0, 0, background, false)
				screen:blit(24, 21, bossbg1)
				curve_display()
				screen:blit(ball_x, ball_y, ball)
				animatePaddle()
				explode(paddle_x, paddle_y)
				screen:blit(24, 21, water)
				screen.flip()
			end
			death()
		elseif dropgrid.y2 < 200 and dropgrid.y2 > 185 and dropgrid.x2 > paddle_x and dropgrid.x2 < (paddle_x + paddle_width) then
			dropgrid = null
			for i=1,60 do
				screen.waitVblankStart(1)
				screen:blit(0, 0, background, false)
				screen:blit(24, 21, bossbg1)
				curve_display()
				screen:blit(ball_x, ball_y, ball)
				animatePaddle()
				explode(paddle_x, paddle_y)
				screen:blit(24, 21, water)
				screen.flip()
			end
			death()
		elseif dropgrid.y3 < 200 and dropgrid.y3 > 185 and dropgrid.x3 > paddle_x and dropgrid.x3 < (paddle_x + paddle_width) then
			dropgrid = null
			for i=1,60 do
				screen.waitVblankStart(1)
				screen:blit(0, 0, background, false)
				screen:blit(24, 21, bossbg1)
				curve_display()
				screen:blit(ball_x, ball_y, ball)
				animatePaddle()
				explode(paddle_x, paddle_y)
				screen:blit(24, 21, water)
				screen.flip()
			end
			death()
		end
	end
	if bossattack ~= 0 then
		if (ball_x + 2) > bossArray.x and (ball_x + 2) < (bossArray.x + bossArray.w) then
			if (ball_y + 2) > 200 then
				y_motion = y_motion * -1
				bosshit()
			end
		end
	end
end

function boss2misslefire()
	if boss2missles.m1y ~= bossArray.y and boss2missles.m1y >= 20 then
		boss2missles.m1y = boss2missles.m1y - 3
		screen:blit(boss2missles.m1x, boss2missles.m1y, boss2missles.m1i)
	end
	if boss2missles.m2y ~= bossArray.y and boss2missles.m2y >= 20 then
		boss2missles.m2y = boss2missles.m2y - 3
		screen:blit(boss2missles.m2x, boss2missles.m2y, boss2missles.m2i)
	end
	if boss2missles.m3y ~= bossArray.y and boss2missles.m3y >= 20 then
		boss2missles.m3y = boss2missles.m3y - 3
		screen:blit(boss2missles.m3x, boss2missles.m3y, boss2missles.m3i)
	end
end

function boss2missleinit()
	dropgrid = {}
	dropgrid.x1 = math.random(25,280)
	dropgrid.x2 = math.random(25,280)
	dropgrid.x3 = math.random(25,280)
	
	dropgrid.y1 = 20
	dropgrid.y2 = 20
	dropgrid.y3 = 20
end

function showlevel ()  --*************************************
	n = 1
	emptytest = 0
	hit = 0
	powerup = math.random(1,10)
	poweruptype = math.random(1,7)
	coll_ballx = ball_x + (ball_x + 5)
	coll_bally = ball_y + (ball_y + 5)
	coll_oldballx = oldball_x + (oldball_x + 5)
	coll_oldbally = oldball_y + (oldball_y + 5)
	while blocklist[n] ~= nul do
		if hit == 0 and blocklist[n][4] > 0 and paddleinitialize ~= 1 then
			if coll_bally >= blocklist[n][6] and coll_bally <= blocklist[n][8] and coll_ballx >= blocklist[n][5] and coll_ballx <= blocklist[n][7] then
				if blocklist[n][4] < 5 then
					blocklist[n][4] = blocklist[n][4] - 1
					if blocklist[n][4] == 1 then
						blocklist[n][3] = scroll_golden_2
					end
					newHigh = newHigh + 100 + (difficulty * 100)							
					if blocklist[n][4] == 0 then
						if powerup == 1 then
							powerupq[powerupcount] = {}
							powerupq[powerupcount][1] = blocklist[n][1] + 7
							powerupq[powerupcount][2] = blocklist[n][2]
							if poweruptype == 1 then
								powerupq[powerupcount][3] = powerupextend
							end
							if poweruptype == 2 then
								powerupq[powerupcount][3] = powerupcurve
							end
							if poweruptype == 3 then
								powerupq[powerupcount][3] = poweruppaddle_f
							end
							if poweruptype == 4 then
								powerupq[powerupcount][3] = poweruppaddle_s
							end
							if poweruptype == 5 then
								powerupq[powerupcount][3] = poweruptime_f
							end
							if poweruptype == 6 then
								powerupq[powerupcount][3] = poweruptime_s
							end
							if poweruptype == 7 then
								powerupq[powerupcount][3] = powerupstickyball
							end
							powerupq[powerupcount][4] = poweruptype
							powerupcount = powerupcount + 1
						end
					end
				end
				cc = 0
				if oldball_y < blocklist[n][2] + blocklist[n][11] and oldball_y > blocklist[n][2] or oldball_y + 5 < blocklist[n][2] + blocklist[n][11] and oldball_y + 5 > blocklist[n][2] then
					x_motion = x_motion * -1
					cc = 1
				end
				if oldball_x < blocklist[n][1] + blocklist[n][10] and oldball_x > blocklist[n][1] and cc == 0 or oldball_x + 5 < blocklist[n][1] + blocklist[n][10] and oldball_x + 5 > blocklist[n][1] and cc == 0 then
					y_motion = y_motion * -1
					cc = 1
				end
				if cc == 0 then
				x_motion = x_motion * -1
					y_motion = y_motion * -1
				end
				block_hit = block_h:play()
				hit = 1
			end
		end
					
		if blocklist[n][4] > 0 then
			screen:blit(blocklist[n][1], blocklist[n][2], blocklist[n][3])
			if blocklist[n][4] < 5 then
				emptytest = 1
			end
		end
		n = n + 1
	end
	if bossArray.life > 0 then
		if level == onebosslevel then
			animateBoss1()
			hit = 0
			local bodyx1 = (bossArray.x + 32) + ((bossArray.x + 32) + 5)-10
			local bodyx2 = (bossArray.x + 39) + ((bossArray.x + 39) + 5)
			local bodyy1 = (bossArray.y + 1) + ((bossArray.y + 1) + 5)-10
			local bodyy2 = (bossArray.y + 42) + ((bossArray.y + 42) + 5)

			local wingx1 = (bossArray.x + 1) + ((bossArray.x + 1) + 5)-10
			local wingx2 = (bossArray.x + 72) + ((bossArray.x + 72) + 5)
			local wingy1 = (bossArray.y + 11) + ((bossArray.y + 11) + 5)-10
			local wingy2 = (bossArray.y + 24) + ((bossArray.y + 24) + 5)

			if coll_bally <= bodyy2 and coll_bally >= bodyy1 then
				if coll_ballx <= bodyx2 and coll_ballx >= bodyx1 then
					if ball_y < bossArray.y+27 and ball_y > bossArray.y+21 then
						bosshit()
					end
					if coll_oldballx < bodyx1 or coll_oldballx > bodyx2 then
						x_motion = x_motion * -1
					end
					if coll_oldbally < bodyy1 or coll_oldbally > bodyy2 then
						y_motion = y_motion * -1
					end
					block_hit = block_h:play()
					hit = 1
				end
			end
			if coll_bally <= wingy2 and coll_bally >= wingy1 then
				if coll_ballx <= wingx2 and coll_ballx >= wingx1 then
					if coll_oldballx < wingx1 or coll_oldballx > wingx2 then
						x_motion = x_motion * -1
						ball_x = ball_x + x_motion
					end
					if coll_oldbally < wingy1 or coll_oldbally > wingy2 then
						y_motion = y_motion * -1
						ball_y = ball_y + y_motion
					end
					block_hit = block_h:play()
					hit = 1
				end
			end
			emptytest = 1
		end

		if level == twobosslevel then
			animateboss2()
			if bossArray.life > 0 then
				emptytest = 1
			else
				emptytest = 0
			end
		end
	end
	gameStatus()
	if emptytest == 0 then
		victory()
	end
end --********************************************************

function paddlestart () --************************************

	pad = Controls.read()
	while pad:cross() do
		pad = Controls.read()
	end

	ball_x = paddle_x
	ball_y = paddle_y
	oldball_x = ball_x
	oldball_y = ball_y
	ball_x_offset = 25
	while true do
		screen.waitVblankStart(1)
		screen:blit(0, 0, background, false)
		if v == true then
			break
		end
		curve_display()
		showlevel()
		screen:blit(ball_x, ball_y, ball)
		animatePaddle()
		powerupcollision()
		if currentpoweruptimer >= 0 then
			powerupdisplay()
		end
		screen.flip()

		pad = Controls.read()
		if pad:left() then
			if paddle_x > left then
				paddle_x = paddle_x - 3
			end
        	end
	
		if pad:right() then
			if paddle_x < right - paddle_width then
				paddle_x = paddle_x + 3
			end
        	end
		if pad:l() then
			if ball_x > paddle_x then
				ball_x_offset = ball_x_offset - 2
			end
        	end
	
		if pad:r() then
			if ball_x < paddle_x + paddle_width - 5 then
				ball_x_offset = ball_x_offset + 2
			end
        	end

		if pad:analogX() > 30 then
			if paddle_x <= right - paddle_width then
				paddle_x = paddle_x + 3
			end
		end

		if pad:analogX() < -30 then
			if paddle_x >= left then
				paddle_x = paddle_x - 3
			end
		end

		if pad:cross() then
			mtest = 0
			if ball_x+2 < paddle_x + (paddle_width*.20) then
				x_motion = -3 - difficulty
				y_motion = -2 - difficulty
				mtest = 1
			end
			if ball_x+2 < paddle_x + (paddle_width*.36) and mtest == 0 then
				x_motion = -2 - difficulty
				y_motion = -2 - difficulty
				mtest = 1
			end
			if ball_x+2 < paddle_x + (paddle_width*.50) and mtest == 0 then
				x_motion = -1 - difficulty
				y_motion = -2 - difficulty
				mtest = 1
			end
			if ball_x+2 < paddle_x + (paddle_width*.64) and mtest == 0 then
				x_motion = 1 + difficulty
				y_motion = -2 - difficulty
				mtest = 1
			end
			if ball_x+2 < paddle_x + (paddle_width*.80) and mtest == 0 then
				x_motion = 2 + difficulty
				y_motion = -2 - difficulty
				mtest = 1
			end
			if ball_x+2 < paddle_x + paddle_width and mtest == 0 then
				x_motion = 3 + difficulty
				y_motion = -2 - difficulty
				mtest = 1
			end
			break
        	end
		if pad:start() then
                	pause ()
        	end
		ball_x = paddle_x + ball_x_offset
		ball_y = paddle_y
	end
end

function animatePaddle()
	if paddlestate == 6 then
		screen:blit(paddle_x, paddle_y, paddle1)
	elseif paddlestate == 5 then
		screen:blit(paddle_x, paddle_y, paddle2)
	elseif paddlestate == 4 then
		screen:blit(paddle_x, paddle_y, paddle3)
	elseif paddlestate == 3 then
		screen:blit(paddle_x, paddle_y, paddle2)
	elseif paddlestate == 2 then
		screen:blit(paddle_x, paddle_y, paddle1)
	elseif paddlestate == 1 then
		screen:blit(paddle_x, paddle_y, paddle4)
	elseif paddlestate <= 0 then
		screen:blit(paddle_x, paddle_y, paddle1)
		paddlestate = 6
	end

	if paddlestate < 6 then
		if paddlestatedelay == 0 then
			paddlestate = paddlestate - 1
			paddlestatedelay = 1
		else
			paddlestatedelay = paddlestatedelay - 1
		end
	end

	if paddlestate == 15 then
		screen:blit(paddle_x, paddle_y, xpaddle1)
	elseif paddlestate == 14 then
		screen:blit(paddle_x, paddle_y, xpaddle1)
	elseif paddlestate == 13 then
		screen:blit(paddle_x, paddle_y, xpaddle2)
	elseif paddlestate == 12 then
		screen:blit(paddle_x, paddle_y, xpaddle3)
	elseif paddlestate == 11 then
		screen:blit(paddle_x, paddle_y, xpaddle2)
	elseif paddlestate == 10 then
		screen:blit(paddle_x, paddle_y, xpaddle1)
	elseif paddlestate == 9 then
		screen:blit(paddle_x, paddle_y, xpaddle4)
	elseif paddlestate == 8 then
		screen:blit(paddle_x, paddle_y, xpaddle1)
		paddlestate = 15
	end

	if paddlestate < 15 and paddlestate > 6 then
		if paddlestatedelay == 0 then
			paddlestate = paddlestate - 1
			paddlestatedelay = 1
		else
			paddlestatedelay = paddlestatedelay - 1
		end
	end

	if paddlestate == 30 then
		screen:blit(paddle_x, paddle_y, paddle1)
	elseif paddlestate == 29 then
		screen:blit(paddle_x, paddle_y, paddlemorph1)
	elseif paddlestate == 28 then
		screen:blit(paddle_x, paddle_y, paddlemorph2)
	elseif paddlestate == 27 then
		screen:blit(paddle_x, paddle_y, paddlemorph3)
	elseif paddlestate == 26 then
		screen:blit(paddle_x, paddle_y, paddlemorph4)
		paddlestate = 15
	end

	if paddlestate < 31 and paddlestate > 15 then
		if paddlestatedelay == 0 then
			paddlestate = paddlestate - 1
			paddlestatedelay = 1
		else
			paddlestatedelay = paddlestatedelay - 1
		end
	end

	if paddlestate == 40 then
		screen:blit(paddle_x, paddle_y, xpaddle1)
	elseif paddlestate == 39 then
		screen:blit(paddle_x, paddle_y, paddlemorph4)
	elseif paddlestate == 38 then
		screen:blit(paddle_x, paddle_y, paddlemorph3)
	elseif paddlestate == 37 then
		screen:blit(paddle_x, paddle_y, paddlemorph2)
	elseif paddlestate == 36 then
		screen:blit(paddle_x, paddle_y, paddlemorph1)
		paddlestate = 6
	end

	if paddlestate < 41 and paddlestate > 30 then
		if paddlestatedelay == 0 then
			paddlestate = paddlestate - 1
			paddlestatedelay = 1
		else
			paddlestatedelay = paddlestatedelay - 1
		end
	end
end

function powerupdisplay()
	if currentpoweruptimer > 0 then
		if currentpoweruptype == 1 then
			local temp = ((currentpoweruptimer/poweruptimermax) * 40)
			screen:blit(335, 207, rep_extension_g)
			screen:blit(335, 207 + 40 - temp, rep_extension, 0, 40 - temp, 40, temp)
		end
		if currentpoweruptype == 2 then
			local temp = ((currentpoweruptimer/poweruptimermax) * 40)
			screen:blit(335, 207, rep_curve_g)
			screen:blit(335, 207 + 40 - temp, rep_curve, 0, 40 - temp, 40, temp)
		end
		if currentpoweruptype == 3 then
			local temp = ((currentpoweruptimer/600) * 40)
			screen:blit(335, 207, rep_paddle_speed_g)
			screen:blit(335, 207 + 40 - temp, rep_paddle_speed, 0, 40 - temp, 40, temp)
		end
		if currentpoweruptype == 4 then
			local temp = ((currentpoweruptimer/600) * 40)
			screen:blit(335, 207, rep_paddle_slow_g)
			screen:blit(335, 207 + 40 - temp, rep_paddle_slow, 0, 40 - temp, 40, temp)
		end
		if currentpoweruptype == 5 then
			local temp = ((currentpoweruptimer/poweruptimermax) * 40)
			screen:blit(335, 207, rep_time_speed_g)
			screen:blit(335, 207 + 40 - temp, rep_time_speed, 0, 40 - temp, 40, temp)
		end
		if currentpoweruptype == 6 then
			local temp = ((currentpoweruptimer/poweruptimermax) * 40)
			screen:blit(335, 207, rep_time_slow_g)
			screen:blit(335, 207 + 40 - temp, rep_time_slow, 0, 40 - temp, 40, temp)
		end
		if currentpoweruptype == 7 then
			local temp = ((currentpoweruptimer/poweruptimermax) * 40)
			screen:blit(335, 207, rep_sticky_g)
			screen:blit(335, 207 + 40 - temp, rep_sticky, 0, 40 - temp, 40, temp)
		end
		currentpoweruptimer = currentpoweruptimer - 1
	else
		if currentpoweruptype == 1 then
			paddlestate = 40
			paddle_width = 50
		end
		if currentpoweruptype == 2 then
			curve_time = curve_max
		end
		if currentpoweruptype == 3 then
			poweruppaddlemod = 0
		end
		if currentpoweruptype == 4 then
			poweruppaddlemod = 0
		end
		if currentpoweruptype == 5 then
			bspeedMod = 0
		end
		if currentpoweruptype == 6 then
			bspeedMod = 0
		end
		if currentpoweruptype == 7 then
			stickypower = 0
		end
		currentpoweruptimer = currentpoweruptimer - 1
	end
end

function powerupcollision()
--******************************** Power-Up Collision *********************************************
emptycheck = 0
for i=1, powerupcount do
	if powerupq[i] ~= null then
		if powerupq[i][2] + 20 < bottom then
			if powerupq[i][2]+10 > paddle_y and powerupq[i][2]+10 < paddle_y + 10 then
				if powerupq[i][1]+10 > paddle_x and powerupq[i][1]+10 < paddle_x + paddle_width then
					if powerupq[i][4] ==  1 then
						currentpoweruptype = 1
						currentpoweruptimer = poweruptimermax
						paddle_width = 80
						paddlestate = 30
						poweruppaddlemod = 0
						bspeedMod = 0
						stickypower = 0
						powerupq[i] = null
					end
					if powerupq[i] ~= null then
					if powerupq[i][4] ==  2 then
						currentpoweruptype = 2
						currentpoweruptimer = 0
						paddle_width = 50
						paddlestate = 6
						poweruppaddlemod = 0
						bspeedMod = 0
						stickypower = 0
						powerupq[i] = null
					end
					end
					if powerupq[i] ~= null then
					if powerupq[i][4] ==  3 then
						currentpoweruptype = 3
						currentpoweruptimer = 600
						paddle_width = 50
						paddlestate = 6
						poweruppaddlemod = 2
						bspeedMod = 0
						stickypower = 0
						powerupq[i] = null
					end
					end
					if powerupq[i] ~= null then
					if powerupq[i][4] ==  4 then
						currentpoweruptype = 4
						currentpoweruptimer = 600
						paddle_width = 50
						paddlestate = 6
						poweruppaddlemod = -2
						bspeedMod = 0
						stickypower = 0
						powerupq[i] = null
					end
					end
					if powerupq[i] ~= null then
					if powerupq[i][4] ==  5 then
						currentpoweruptype = 5
						currentpoweruptimer = poweruptimermax
						paddle_width = 50
						paddlestate = 6
						poweruppaddlemod = 0
						bspeedMod = 1
						stickypower = 0
						powerupq[i] = null
					end
					end
					if powerupq[i] ~= null then
					if powerupq[i][4] ==  6 then
						currentpoweruptype = 6
						currentpoweruptimer = poweruptimermax
						paddle_width = 50
						paddlestate = 6
						poweruppaddlemod = 0
						bspeedMod = -1
						stickypower = 0
						powerupq[i] = null
					end
					end
					if powerupq[i] ~= null then
					if powerupq[i][4] ==  7 then
						currentpoweruptype = 7
						currentpoweruptimer = poweruptimermax
						paddle_width = 50
						paddlestate = 6
						poweruppaddlemod = 0
						bspeedMod = 0
						stickypower = 1
						powerupq[i] = null
					end
					end
					if powerupq[i] ~= null then
					if powerupq[i][4] == 8 then
						for i=1,60 do
							screen.waitVblankStart(1)
							screen:blit(0, 0, background, false)
							curve_display()
							screen:blit(ball_x, ball_y, ball)
							animatePaddle()
							explode(paddle_x, paddle_y)
							screen.flip()
						end
						death()
						powerupq[i] = null
					end
					end
				end
			end	
			if powerupq[i] ~= null then
				screen:blit(powerupq[i][1], powerupq[i][2], powerupq[i][3])
				powerupq[i][2] = powerupq[i][2] + 1
				if powerupq[i][4] == 8 then
					powerupq[i][2] = powerupq[i][2] + 1
				end
				emptycheck = 1
			end
		else
			powerupq[i] = null
		end
	end
end
if emptycheck == 0 then
	powerupq = {}
	powerupcount = 1
end
end--********************************************************************************************

function curve_display()
	curve_temp = (curve_time/curve_max)*276
	screen:blit(20, 4, curve_meter)
	screen:blit(12 + 276 - curve_temp, 2, curve_meter_marker)
end

function play()--*********************************************************
	paddle_width = 50
	curvedelay = 6  - difficulty
	paddlestate = 6
	paddlestatedelay = 1
	currentpoweruptimer = - 1
	poweruppaddlemod = 0
	stickypower = 0
	bspeedMod = 0
	while true do  
		screen:clear()
		if exittomenu == 1 then
			musicfadeout()
			Music.stop()
			Music.volume(gamevolume)
			break
		end
		if paddleinitialize == 1 then
			if stickypower == 0 then
				paddle_x = 82
			end
			paddlestart ()
			paddleinitialize = 0
		end

		if v == true then
			musicfadeout()
			Music.stop()
			Music.volume(gamevolume)
			break
		end

		screen:blit(0, 0, background, false)
		showlevel()
		if v == true then
			musicfadeout()
			Music.stop()
			Music.volume(gamevolume)
			break
		end
		screen:blit(ball_x, ball_y, ball)
		animatePaddle()
		curve_display()
		powerupcollision()
		if currentpoweruptimer >= 0 then
			powerupdisplay()
		end

		screen.waitVblankStart(1)
		screen.flip()
		
	--***************************Ball Movement********************
		oldball_x = ball_x
		oldball_y = ball_y
		if x_motion > 0 then
			ball_x = ball_x + x_motion + bspeedMod
		elseif x_motion < 0 then
			ball_x = ball_x + x_motion - bspeedMod
		end
		if y_motion > 0 then
			ball_y = ball_y + y_motion + bspeedMod
		else
			ball_y = ball_y + y_motion - bspeedMod
		end

		--**************************Collision with walls******************************
		if ball_y >= bottom then
			powerupq = {}
			currentpoweruptimer = 0
			death ()
			if v == true then
				break
			end
		end
		if ball_y <= top then
			y_motion = y_motion * -1
			while ball_y < top do
				ball_y = ball_y + 3
			end
		end
		if ball_x >= right then
			x_motion = x_motion * -1
			while ball_x > right do
				ball_x = ball_x - 3
			end
		end
		if ball_x <= left then
			x_motion = x_motion * -1
			while ball_x < left do
				ball_x = ball_x + 3
			end
		end

	--**********************Handles Collision With Paddle***********
		mtest = 0
		if ball_y+5 >= paddle_y + 10 then
			if ball_x+2 > paddle_x and ball_x+2 < paddle_x + paddle_width then
				if ball_x+2 < paddle_x + (paddle_width*.20) then
					x_motion = -3 - difficulty
					y_motion = y_motion * -1
					mtest = 1
					paddlestate = paddlestate - 1
					wall_hit = wall_h:play()
				end
				if ball_x+2 < paddle_x + (paddle_width*.36) and mtest == 0 then
					x_motion = -2 - difficulty
					y_motion = y_motion * -1
					mtest = 1
					paddlestate = paddlestate - 1
					wall_hit = wall_h:play()
				end
				if ball_x+2 < paddle_x + (paddle_width*.50) and mtest == 0 then
					y_motion = y_motion * -1
					mtest = 1
					paddlestate = paddlestate - 1
					wall_hit = wall_h:play()
				end
				if ball_x+2 < paddle_x + (paddle_width*.64) and mtest == 0 then
					y_motion = y_motion * -1
					mtest = 1
					paddlestate = paddlestate - 1
					wall_hit = wall_h:play()
				end
				if ball_x+2 < paddle_x + (paddle_width*.80) and mtest == 0 then
					x_motion = 2 + difficulty
					y_motion = y_motion * -1
					mtest = 1
					paddlestate = paddlestate - 1
					wall_hit = wall_h:play()
				end
				if ball_x+2 < paddle_x + paddle_width and mtest == 0 then
					x_motion = 3 + difficulty
					y_motion = y_motion * -1
					mtest = 1
					paddlestate = paddlestate - 1
					wall_hit = wall_h:play()
				end
				while ball_y+5 >= paddle_y+5 do
					ball_y = ball_y - 1
				end
				if stickypower == 1 then
					paddleinitialize = 1
				end
			end
		end

	--***************************Handles Pad Movement*****************	
		pad = Controls.read()
		if pad:left() then
			if paddle_x >= left then
				paddle_x = paddle_x - 3 - poweruppaddlemod
			end
		end
		
		if pad:right() then
			if paddle_x <= right - paddle_width then
				paddle_x = paddle_x + 3 + poweruppaddlemod
			end
		end
		--*********************** CURVE CONTROLS ***************************************
		if pad:l() then
			if curve_time > 0 then
				curve_time = curve_time - 1
				if curvedelay == 1 then
					if x_motion > (-3 - difficulty) then
						x_motion = x_motion - 1
					end
				end
			end
		elseif pad:r() then
			if curve_time > 0 then
				curve_time = curve_time - 1
				if curvedelay == 1 then
					if x_motion < (3 + difficulty) then
						x_motion = x_motion + 1
					end
				end
			end
		else
			if curvedelay == 1 and curve_time <= 6  - difficulty then
				curve_time = curve_time + 1
			end
		end
		--******************************************************************************

		if pad:analogX() > 30 then 
			if paddle_x <= right - paddle_width then
				paddle_x = paddle_x + 3 + poweruppaddlemod
			end
		end

		if pad:analogX() < -30 then
			if paddle_x >= left then
				paddle_x = paddle_x - 3 - poweruppaddlemod
			end
		end

		curvedelay = curvedelay - 1
		if curvedelay <= 0 then
			curvedelay = 6 - difficulty
		end

		if pad:start() then
			pause ()
		end 
		if pad:select() then
			screen:save("main.png")
		end
	end 
end

--**********************************************************************************************************************
--****************************************** Level Builder *************************************************************
--**********************************************************************************************************************
function repairlevel(myArray)
	n = 1
	while myArray[n] ~= nul do
		if myArray[n][9] == 1 then
			if myArray[n][12] == 7 then
				myArray[n][4] = 2
				myArray[n][3] = scroll_golden_1
			else
				myArray[n][4] = 1
			end
			if myArray[n][12] == 1 then
				myArray[n][3] = scroll_main
			end
			if myArray[n][12] == 2 then
				myArray[n][3] = scroll_blue
			end
			if myArray[n][12] == 3 then
				myArray[n][3] = scroll_green
			end
			if myArray[n][12] == 4 then
				myArray[n][3] = scroll_orange
			end
			if myArray[n][12] == 5 then
				myArray[n][3] = scroll_purple
			end
			if myArray[n][12] == 6 then
				myArray[n][3] = scroll_red
			end
			myArray[n][10] = 35
			myArray[n][11] = 10
		end
		if myArray[n][9] == 2 then
			myArray[n][4] = 5
			if myArray[n][12] == 1 then
				myArray[n][3] = block10x70
				myArray[n][10] = 10
				myArray[n][11] = 70
			end
			if myArray[n][12] == 2 then
				myArray[n][3] = block35x50
				myArray[n][10] = 35
				myArray[n][11] = 50
			end
			if myArray[n][12] == 3 then
				myArray[n][3] = block25x100
				myArray[n][10] = 25
				myArray[n][11] = 100
			end
		end
		if myArray[n][9] == 3 then
			myArray[n][4] = 5
			if myArray[n][12] == 1 then
				myArray[n][3] = block20x20
				myArray[n][10] = 20
				myArray[n][11] = 20
			end
			if myArray[n][12] == 2 then
				myArray[n][3] = block25x25
				myArray[n][10] = 25
				myArray[n][11] = 25
			end
			if myArray[n][12] == 3 then
				myArray[n][3] = block30x30
				myArray[n][10] = 30
				myArray[n][11] = 30
			end
			if myArray[n][12] == 4 then
				myArray[n][3] = block35x35
				myArray[n][10] = 35
				myArray[n][11] = 35
			end
			if myArray[n][12] == 5 then
				myArray[n][3] = block40x40
				myArray[n][10] = 40
				myArray[n][11] = 40
			end
			if myArray[n][12] == 6 then
				myArray[n][3] = block45x45
				myArray[n][10] = 45
				myArray[n][11] = 45
			end
			if myArray[n][12] == 7 then
				myArray[n][3] = block50x50
				myArray[n][10] = 50
				myArray[n][11] = 50
			end
		end
		if myArray[n][9] == 4 then
			myArray[n][4] = 5
			if myArray[n][12] == 1 then
				myArray[n][3] = block35x10
				myArray[n][10] = 35
				myArray[n][11] = 10
			end
			if myArray[n][12] == 2 then
				myArray[n][3] = block70x20
				myArray[n][10] = 70
				myArray[n][11] = 20
			end
			if myArray[n][12] == 3 then
				myArray[n][3] = block105x10
				myArray[n][10] = 105
				myArray[n][11] = 10
			end
			if myArray[n][12] == 4 then
				myArray[n][3] = block105x50
				myArray[n][10] = 105
				myArray[n][11] = 50
			end
		end
		n = n + 1
	end
end
		
function buildcustomlevel()
while true do
	screen:blit(0, 0, bg)
	local j = 1
	local k = 1
	local l = 0
	for i=1, c do
		if blocklist[i][1] < 10 then
			spacer = "   "
		elseif blocklist[i][1] < 100 and blocklist[i][1] > 9 then
			spacer = "  "
		elseif blocklist[i][1] < 1000 and blocklist[i][1] > 99 then
			spacer = " "
		end
		screen:blit(blocklist[i][1], blocklist[i][2], blocklist[i][3])
		if i == item then
			screen:print(310+l, 5+(j*9), blocklist[i][1] .. spacer .. blocklist[i][2], pink)
			screen:blit(blocklist[i][1]+(blocklist[i][10]/2)-3, blocklist[i][2]+(blocklist[i][11]/2)-3, dot)
		else
			screen:print(310+l, 5+(j*9), blocklist[i][1] .. spacer .. blocklist[i][2], white)
		end
		j = j + 1
		k = k + 1
		if k == 26 then
			j = 1
			l = 80
			k = 1
		end
	end
	screen.flip()
--*************************************************************************update block****************
		if blocklist[item][9] == 1 then
			if blocklist[item][12] == 7 then
				blocklist[item][4] = 2
				blocklist[item][3] = scroll_golden_1
			else
				blocklist[item][4] = 1
			end
			if blocklist[item][12] == 1 then
				blocklist[item][3] = scroll_main
			end
			if blocklist[item][12] == 2 then
				blocklist[item][3] = scroll_blue
			end
			if blocklist[item][12] == 3 then
				blocklist[item][3] = scroll_green
			end
			if blocklist[item][12] == 4 then
				blocklist[item][3] = scroll_orange
			end
			if blocklist[item][12] == 5 then
				blocklist[item][3] = scroll_purple
			end
			if blocklist[item][12] == 6 then
				blocklist[item][3] = scroll_red
			end
			blocklist[item][10] = 35
			blocklist[item][11] = 10
		elseif blocklist[item][9] == 2 then
			blocklist[item][4] = 5
			if blocklist[item][12] == 1 then
				blocklist[item][3] = block10x70
				blocklist[item][10] = 10
				blocklist[item][11] = 70
			end
			if blocklist[item][12] == 2 then
				blocklist[item][3] = block35x50
				blocklist[item][10] = 35
				blocklist[item][11] = 50
			end
			if blocklist[item][12] == 3 then
				blocklist[item][3] = block25x100
				blocklist[item][10] = 25
				blocklist[item][11] = 100
			end
		elseif blocklist[item][9] == 3 then
			blocklist[item][4] = 5
			if blocklist[item][12] == 1 then
				blocklist[item][3] = block20x20
				blocklist[item][10] = 20
				blocklist[item][11] = 20
			end
			if blocklist[item][12] == 2 then
				blocklist[item][3] = block25x25
				blocklist[item][10] = 25
				blocklist[item][11] = 25
			end
			if blocklist[item][12] == 3 then
				blocklist[item][3] = block30x30
				blocklist[item][10] = 30
				blocklist[item][11] = 30
			end
			if blocklist[item][12] == 4 then
				blocklist[item][3] = block35x35
				blocklist[item][10] = 35
				blocklist[item][11] = 35
			end
			if blocklist[item][12] == 5 then
				blocklist[item][3] = block40x40
				blocklist[item][10] = 40
				blocklist[item][11] = 40
			end
			if blocklist[item][12] == 6 then
				blocklist[item][3] = block45x45
				blocklist[item][10] = 45
				blocklist[item][11] = 45
			end
			if blocklist[item][12] == 7 then
				blocklist[item][3] = block50x50
				blocklist[item][10] = 50
				blocklist[item][11] = 50
			end
		elseif blocklist[item][9] == 4 then
			blocklist[item][4] = 5
			if blocklist[item][12] == 1 then
				blocklist[item][3] = block35x10
				blocklist[item][10] = 35
				blocklist[item][11] = 10
			end
			if blocklist[item][12] == 2 then
				blocklist[item][3] = block70x20
				blocklist[item][10] = 70
				blocklist[item][11] = 20
			end
			if blocklist[item][12] == 3 then
				blocklist[item][3] = block105x10
				blocklist[item][10] = 105
				blocklist[item][11] = 10
			end
			if blocklist[item][12] == 4 then
				blocklist[item][3] = block105x50
				blocklist[item][10] = 105
				blocklist[item][11] = 50
			end
		end
--*************************************************************************update block****************

	pad = Controls.read()
	if pad:analogX() < -30 then
		if blocklist[item][1] >= left then
			blocklist[item][1] = blocklist[item][1] - movespeed
		end
        end
	if pad:analogX() > 30 then
		if blocklist[item][1]+blocklist[item][10] <= right then
			blocklist[item][1] = blocklist[item][1] + movespeed
		end
        end
	if pad:analogY() < -30 then
		if blocklist[item][2] >= top then
			blocklist[item][2] = blocklist[item][2] - movespeed
		end
        end
	if pad:analogY() > 30 then
		if blocklist[item][2]+blocklist[item][11] <= bottom then
			blocklist[item][2] = blocklist[item][2] + movespeed
		end
        end
	if pad:up() then
		if blocklist[item][2] >= top then
			blocklist[item][2] = blocklist[item][2] - 1
		end
		screen.waitVblankStart(10)
	end
	if pad:down() then
		if blocklist[item][2]+blocklist[item][11] <= bottom then
			blocklist[item][2] = blocklist[item][2] + 1
		end
		screen.waitVblankStart(10)
	end
	if pad:left() then
		if blocklist[item][1] >= left then
			blocklist[item][1] = blocklist[item][1] - 1
		end
		screen.waitVblankStart(10)
	end
	if pad:right() then
		if blocklist[item][1]+blocklist[item][10] <= right then
			blocklist[item][1] = blocklist[item][1] + 1
		end
		screen.waitVblankStart(10)
	end
	if pad:cross() then
		item = item + 1
		if blocklist[item] == null then
			blocklist[item] = {}
			blocklist[item][1] = left + 1
			blocklist[item][2] = top + 1
			blocklist[item][3] = blocklist[item-1][3]
			blocklist[item][4] = blocklist[item-1][4]
			blocklist[item][9] = blocklist[item-1][9]
			blocklist[item][10] = blocklist[item-1][10]
			blocklist[item][11] = blocklist[item-1][11]
			blocklist[item][12] = blocklist[item-1][12]
			c = c + 1
		end
		while pad:cross() do
			pad = Controls.read()
			screen.waitVblankStart()
		end
        end
	if pad:circle() then
		if item ~= 1 then
			item = item - 1
		end
		while pad:circle() do
			pad = Controls.read()
			screen.waitVblankStart()
		end
	end

	if pad:l() then
		if blocklist[item][9] == 1 then
			if blocklist[item][12] > 0 then
				blocklist[item][12] = blocklist[item][12] - 1
			end
			if blocklist[item][12] == 0 then
				blocklist[item][12] = 7
			end
		end
		if blocklist[item][9] == 2 then
			if blocklist[item][12] > 0 then
				blocklist[item][12] = blocklist[item][12] - 1
			end
			if blocklist[item][12] == 0 then
				blocklist[item][12] = 3
			end
		end
		if blocklist[item][9] == 3 then
			if blocklist[item][12] > 0 then
				blocklist[item][12] = blocklist[item][12] - 1
			end
			if blocklist[item][12] == 0 then
				blocklist[item][12] = 7
			end
		end
		if blocklist[item][9] == 4 then
			if blocklist[item][12] > 0 then
				blocklist[item][12] = blocklist[item][12] - 1
			end
			if blocklist[item][12] == 0 then
				blocklist[item][12] = 4
			end
		end

		while pad:l() do
			pad = Controls.read()
			screen.waitVblankStart()
		end
	end

	if pad:r() then
		if blocklist[item][9] == 1 then
			if blocklist[item][12] < 8 then
				blocklist[item][12] = blocklist[item][12] + 1
			end
			if blocklist[item][12] == 8 then
				blocklist[item][12] = 1
			end
		end
		if blocklist[item][9] == 2 then
			if blocklist[item][12] < 4 then
				blocklist[item][12] = blocklist[item][12] + 1
			end
			if blocklist[item][12] == 4 then
				blocklist[item][12] = 1
			end
		end
		if blocklist[item][9] == 3 then
			if blocklist[item][12] < 8 then
				blocklist[item][12] = blocklist[item][12] + 1
			end
			if blocklist[item][12] == 8 then
				blocklist[item][12] = 1
			end
		end
		if blocklist[item][9] == 4 then
			if blocklist[item][12] < 5 then
				blocklist[item][12] = blocklist[item][12] + 1
			end
			if blocklist[item][12] == 5 then
				blocklist[item][12] = 1
			end
		end

		while pad:r() do
			pad = Controls.read()
			screen.waitVblankStart()
		end
	end
	
	if pad:triangle() then
		blocklist[item][9] = blocklist[item][9] + 1
		if blocklist[item][9] == 5 then
			blocklist[item][9] = 1
		end
		blocklist[item][12] = 1

		while pad:triangle() do
			pad = Controls.read()
			screen.waitVblankStart()
		end
	end
	if pad:square() then
		if c > 1 then
			p = item
			pp = item+1
			while blocklist[pp] ~= null do
				blocklist[p][1] = blocklist[pp][1]
				blocklist[p][2] = blocklist[pp][2]
				blocklist[p][3] = blocklist[pp][3]
				blocklist[p][4] = blocklist[pp][4]
				blocklist[p][5] = blocklist[pp][5]
				blocklist[p][6] = blocklist[pp][6]
				blocklist[p][7] = blocklist[pp][7]
				blocklist[p][8] = blocklist[pp][8]
				blocklist[p][9] = blocklist[pp][9]
				blocklist[p][10] = blocklist[pp][10]
				blocklist[p][11] = blocklist[pp][11]
				blocklist[p][12] = blocklist[pp][12]
				p = p + 1
				pp = pp + 1
			end
			blocklist[p] = null
			c = c - 1
			if item > 1 then
				item = item - 1
			end
			while pad:square() do
				pad = Controls.read()
				screen.waitVblankStart()
			end
		end
	end

	if pad:start() then
		while pad:start() do
			pad = Controls.read()
			screen.waitVblankStart(1)
		end
		paddleinitialize = 1
		lives = 0
		for i=1, c do
			blocklist[i][5] = blocklist[i][1] + (blocklist[i][1] + 5) - 10
			blocklist[i][6] = blocklist[i][2] + (blocklist[i][2] + 5) - 10
			blocklist[i][7] = blocklist[i][1] + blocklist[i][10] + (blocklist[i][1] + blocklist[i][10] + 5)
			blocklist[i][8] = blocklist[i][2] + blocklist[i][11] + (blocklist[i][2] + blocklist[i][11] + 5)
		end
		level = -1
		curveTimeInit()
		bossArray = {x = 0, y = 0, life = 0, w = 0}
		play()
		v = false
		exittomenu = 0
		repairlevel(blocklist)
	end
	if pad:select() then
		local test = build_menu()
		if test == 1 then
			break
		end
	end
end
end


function build_menu () --******************************************
	pad = Controls.read()
	while pad:select() do
		pad = Controls.read()
	end
	x = 1
	r = 0
	menuOption = {}	
	while true do
		for i = 1, 4 do 			-- graphically displays which menu choice is selected
			if i == x then
				menuOption[i] = pink
			else
				menuOption[i] = white
			end
		end
		
		screen:blit(0, 0, bg, false)
		screen:print(80, 90, "Clear Level", menuOption[1])
		screen:print(80, 110, "Save Level", menuOption[2])
		screen:print(80, 130, "Load Level", menuOption[3])
		screen:print(80, 150, "Exit Level Editor", menuOption[4])
		screen.flip()

		pad = Controls.read()
		if pad:up() then
			if x > 1 then
				x = x - 1
				screen.waitVblankStart(10)
			else
				x = 4
				screen.waitVblankStart(10)
			end
		end

		if pad:down() then
			if x < 4 then
				x = x + 1
				screen.waitVblankStart(10)
			else
				x = 1
				screen.waitVblankStart(10)
			end
		end
			
		if pad:cross() then
			if x == 1 then
				blocklist = {}
				blocklist[1] = {}
				blocklist[1][1] = left + 1
				blocklist[1][2] = top + 1
				blocklist[1][3] = scroll_main
				blocklist[1][4] = 1
				blocklist[1][9] = 1
				blocklist[1][10] = 35
				blocklist[1][11] = 10
				blocklist[1][12] = 1
				item = 1
				c = 1
			end
			if x == 2 then
				while pad:cross() do
					pad = Controls.read()
				end
				savelevel(blocklist)
			end
			if x == 3 then
				while pad:cross() do
					pad = Controls.read()
				end
				blocklist, c = loadlevel(blocklist)
				if blocklist[1] ~= null and choice == 1 then
					screen:print(50, 50, "Loaded Successfully", pink)
					screen.flip()
					screen.waitVblankStart(60)
					item = 1
				else
					if choice == 1 then
						screen:print(50, 50, "Empty File", pink)
						screen.flip()
						screen.waitVblankStart(60)
						item = 1
						blocklist[1] = {}
						blocklist[1][1] = left + 1
						blocklist[1][2] = top + 1
						blocklist[1][3] = scroll_main
						blocklist[1][4] = 1
						blocklist[i][9] = 1
						blocklist[i][10] = 35
						blocklist[i][11] = 10
						blocklist[i][12] = 1
					else
						screen:print(50, 50, "Load Aborted", pink)
						screen.flip()
						screen.waitVblankStart(60)
					end
				end
			end
			if x == 4 then
				while pad:cross() do
					pad = Controls.read()
				end
				r = 1
				musicfadeout()
				Music.stop()
				Music.volume(gamevolume)
				break
			end
        	end

		if pad:select() then
			while pad:select() do
				pad = Controls.read()
			end
			break
		end
	end
	return r
end


function savelevel(myArray)
	local n = 1
	while true do
		screen:clear()
		screen:print(10, 20, "Slot: ", white)
		for i=1, 9 do
			if i == n then
				screen:print(50+(10*i), 20, i, pink)
			else
				screen:print(50+(10*i), 20, i, white)
			end
		end
		screen:print(10, 30, "X - Confirm, O - Cancel", white)
		screen.flip()
		screen.waitVblankStart(10)

		pad = Controls.read()
		if pad:left() then
			if n > 1 then
				n = n - 1
			end
        	end
		if pad:right() then
			if n < 9 then
				n = n + 1
			end
        	end
		if pad:cross() then
			choice = 1
			break
		end
		if pad:circle() then
			choice = 0
			break
		end
	end

	if choice == 1 then
		file = io.open("customlevels/clevel"..n, "w")
		if file then
			if myArray[1] == null then
				screen:print(10, 20, "empty array", pink)
			end
			p = 1
			while blocklist[p] ~= null do
				file:write(myArray[p][1]," ")
				file:write(myArray[p][2]," ")
				file:write(myArray[p][4]," ")
				file:write(myArray[p][9]," ")
				file:write(myArray[p][10]," ")
				file:write(myArray[p][11]," ")
				file:write(myArray[p][12]," ")
				p = p + 1
			end
			file:close()
		end

		screen:print(10, 50, "done", pink)
		screen.flip()
		screen.waitVblankStart(60)
	else
		screen:print(10, 50, "Canceled", pink)
		screen.flip()
		screen.waitVblankStart(60)
	end
end

function loadlevel(myArray)
	local n = 1
	p = 1
	while true do
		screen:clear()
		screen:print(10, 20, "Slot: ", white)
		for i=1, 9 do
			if i == n then
				screen:print(50+(10*i), 20, i, pink)
			else
				screen:print(50+(10*i), 20, i, white)
			end
		end
		screen:print(10, 30, "X - Confirm, O - Cancel", white)
		screen.flip()

		pad = Controls.read()
		if pad:left() then
			if n > 1 then
				n = n - 1
			end
			screen.waitVblankStart(10)
        	end
		if pad:right() then
			if n < 9 then
				n = n + 1
			end
			screen.waitVblankStart(10)
        	end
		if pad:cross() then
			choice = 1
			break
		end
		if pad:circle() then
			choice = 0
			break
		end
	end
	if choice == 1 then
		myArray = {}
		file = io.open("customlevels/clevel"..n, "r")
		if file then 
			temp = file:read("*n")
			if temp == null then
				screen:print(50, 50, "empty file", pink)
				screen.flip()
				screen.waitVblankStart(60)
			else
				while temp ~= null do
					myArray[p] = {}
					myArray[p][1] = temp
					temp = file:read("*n")
					myArray[p][2] = temp
					temp = file:read("*n")
					myArray[p][4] = temp
					temp = file:read("*n")
					myArray[p][9] = temp
					temp = file:read("*n")
					myArray[p][10] = temp
					temp = file:read("*n")
					myArray[p][11] = temp
					temp = file:read("*n")
					myArray[p][12] = temp
					temp = file:read("*n")
					p = p + 1
				end
				p = p - 1
			end
			file:close()
		end
		repairlevel(myArray)
		i = 1
		while myArray[i] ~= null do
			myArray[i][5] = myArray[i][1] + (myArray[i][1] + 5) - 10
			myArray[i][6] = myArray[i][2] + (myArray[i][2] + 5) - 10
			myArray[i][7] = myArray[i][1] + myArray[i][10] + (myArray[i][1] + myArray[i][10] + 5)
			myArray[i][8] = myArray[i][2] + myArray[i][11] + (myArray[i][2] + myArray[i][11] + 5)
			i = i + 1
		end
	end	
	return myArray, p
end

--*********************************************** MAIN **************************************************
customplay = 0
loadgamedata()
intro()
menu ()